Unit Gouraud;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;
var

x,y,x1,y1,x2,y2,x3,y3,xmin,xmax,aux2,aux1,yscan :integer;
delta12,delta23,delta13,deltaMin,deltaMax :real;
Rxmin,Rxmax:real;
CorAR,corBR,CorCR, corAG, corBG,corCG,corAB, corBB, corCB :integer;
Red,Green,Blue:real;
letra: char;
arq: text;
nome: string[30];

type tripla = record
        x,y,z,cor:real;
     end;
var
a,b,c,p,u,v,w:tripla;
alfa, beta, gama:real;
function scanconvert(x1,y1,x2,y2,x3,y3,R1,G1,B1,R2,G2,B2,R3,G3,B3:integer):TBitMap;

implementation

procedure ProdutoVetorial(v,u:tripla;var ret:tripla);
begin
   ret.x:=v.y*u.z - v.z*u.y;
   ret.y:=v.z*u.x - v.x*u.z;
   ret.z:=v.x*u.y - u.x*v.y;
end;

function norma(v:tripla):real;
var ret:real;
begin
   ret:=sqrt(v.x*v.x + v.y*v.y + v.z*v.z);
   norma:=ret;
end;

procedure subtrai(a,b:tripla;var ret:tripla);
begin
   ret.x:=a.x - b.x;
   ret.y:=a.y - b.y;
   ret.z:=a.z - b.z;
end;

procedure CoordenadasBaricentricas(a,b,c,p:tripla;var alfa,beta,gama:real);
var u,v,w:tripla;
    AreaTotal,AreaGama,AreaAlfa,AreaBeta:real;
begin

   subtrai(b,a,v);
   subtrai(c,a,u);
   ProdutoVetorial(v,u,w);
   AreaTotal:=norma(w);

   subtrai(b,p,v);
   subtrai(c,p,u);
   ProdutoVetorial(v,u,w);
   AreaAlfa:=norma(w);
   alfa:=AreaAlfa/AreaTotal;


   subtrai(a,p,v);
   subtrai(c,p,u);
   ProdutoVetorial(v,u,w);
   AreaBeta:=norma(w);
   beta:=AreaBeta/AreaTotal;

   subtrai(b,p,v);
   subtrai(a,p,u);
   ProdutoVetorial(v,u,w);
   AreaGama:=norma(w);
   gama:=AreaGama/AreaTotal;
end;

function scanconvert(x1,y1,x2,y2,x3,y3,R1,G1,B1,R2,G2,B2,R3,G3,B3:integer):TBitMap;
var
x,y,xmin,xmax,aux2,aux1,yscan :integer;
delta12,delta23,delta13,deltaMin,deltaMax :real;
Rxmin,Rxmax:real;
a,b,c:tripla;
p:tripla;
alfa,beta,gama:real;
Red,Green,Blue:Integer;
 Bitmap:TBitMap;

{#################PONTO MAIS ALTO E PONTO INTERMEDIARIO ##################}
begin
 if Bitmap=nil then begin
    Bitmap := TBitmap.Create;
    Bitmap.Width := 550;	{ assign the initial width... }
    Bitmap.Height := 500;	{ ...and the initial height }
 end;

a.x:=x1;
a.y:=y1;
a.z:=0;
b.x:=x2;
b.y:=y2;
b.z:=0;
c.x:=x3;
c.y:=y3;
c.z:=0;
p.z:=0;

if y2>y1 then begin
   aux1 := x1;
   aux2 := y1;
   y1 := y2;
   x1 := x2;
   y2 := aux2;
   x2 := aux1;
end;
if y3>y1 then begin
   aux1 := x1;
   aux2 := y1;
   y1 := y3;
   x1 := x3;
   y3 := aux2;
   x3 := aux1;
end;

{###################PONTO MAIS BAIXO########################################}

if y3>y2 then begin
   aux1 := x2;
   aux2 := y2;
   y2 := y3;
   x2 := x3;
   y3 := aux2;
   x3 := aux1;
end;

{###################CALCULO DOS DELTAS######################################}
if y1=y2 then
   delta12:=0
else
   delta12:= (x2-x1)/(y1-y2);
if y2=y3 then
   delta23:=0
else
   delta23:= (x3-x2)/(y2-y3);
delta13:= (x3-x1)/(y1-y3);



{***********************CALCULO DAS CORES*********************************}
{for x:=xmin to xmax do
Red  := alfa*corAR + beta*corBR + gama*corCR;
Green:= alfa*corAG + beta*corBG + gama*corCG;
Blue := alfa*corAB + beta*corBB + gama*corCB;



{###################ASSOCIAAO DOS DELTAS###################################}

   if delta12=0 then begin
      deltaMin:=delta13;
      deltaMax:=delta23;
      xmin:=x1;
      xmax:=x2;
      if delta13<delta23 then begin
         deltaMin:=delta23;
         deltaMax:=delta13;
         xmin:=x2;
         xmax:=x1;
      end;
      Rxmin := xmin;
      Rxmax := xmax;
      for yscan:=y1 downto y3 do begin
         p.y:=yscan;
         for x:=xmin to xmax do begin
             p.x:=x;
             CoordenadasBaricentricas(a,b,c,p,alfa,beta,gama);
             Red:=trunc(alfa*R1+beta*R2+gama*R3);
             Green:=trunc(alfa*G1+beta*G2+gama*G3);
             Blue:=trunc(alfa*B1+beta*B2+gama*B3);
             Bitmap.Canvas.Pixels[x,yscan] := RGB(Red,Green,Blue);
         end;
         Rxmin:=Rxmin+deltaMin;
         Rxmax:=Rxmax+deltaMax;
         xmin:= trunc(Rxmin+0.5);
         xmax:= trunc(Rxmax+0.5);
      end;
    end
    else begin
      deltaMin:=delta12;
      deltaMax:=delta13;
      xmin:=x1;
      xmax:=x1;
      Rxmin := xmin;
      Rxmax := xmax;
      if delta13<delta12 then begin
         deltaMin:=delta13;
         deltaMax:=delta12;
      end;
      for yscan:=y1 downto y2 do begin
         p.y:=yscan;
         for x:=xmin to xmax do begin
             p.x:=x;
             CoordenadasBaricentricas(a,b,c,p,alfa,beta,gama);
             Red:=trunc(alfa*R1+beta*R2+gama*R3);
             Green:=trunc(alfa*G1+beta*G2+gama*G3);
             Blue:=trunc(alfa*B1+beta*B2+gama*B3);
             Bitmap.Canvas.Pixels[x,yscan] := RGB(Red,Green,Blue);
         end;
         Rxmin:=Rxmin+deltaMin;
         Rxmax:=Rxmax+deltaMax;
         xmin:= trunc(Rxmin+0.5);
         xmax:= trunc(Rxmax+0.5);
      end;
      Rxmin:=Rxmin-deltaMin;
      Rxmax:=Rxmax-deltaMax;
      xmin:= trunc(Rxmin+0.5);
      xmax:= trunc(Rxmax+0.5);
      if delta23<>0 then begin
         deltaMin:=delta13;
         deltaMax:=delta23;
         if delta13<delta23 then begin
            deltaMin:=delta23;
            deltaMax:=delta13;
         end;
         for yscan:=y2 downto y3 do begin
            p.y:=yscan;
            for x:=xmin to xmax do begin
               p.x:=x;
               CoordenadasBaricentricas(a,b,c,p,alfa,beta,gama);
               Red:=trunc(alfa*R1+beta*R2+gama*R3);
               Green:=trunc(alfa*G1+beta*G2+gama*G3);
               Blue:=trunc(alfa*B1+beta*B2+gama*B3);
               Bitmap.Canvas.Pixels[x,yscan] := RGB(Red,Green,Blue);
            end;
           Rxmin:=Rxmin+deltaMin;
           Rxmax:=Rxmax+deltaMax;
           xmin:= trunc(Rxmin+0.5);
           xmax:= trunc(Rxmax+0.5);
        end;
      end;
    end;
    scanconvert:=BitMap;
 end;

end.





