unit uCoordenadas;

interface

uses Classes,Windows,Graphics,ExtCtrls,Forms,SysUtils,Math,uInstrumental_Basico,
uCamera,uCena,uTriangulo;

procedure mundial_para_vista_textura;
procedure mundial_para_vista;
procedure mundial_para_vista_fontes_de_luz;
procedure coordenadas_baricentricas(ax,ay,bx,by,cx,cy,px,py:real;
                                    var alfa,beta,gama:real);
procedure coordenadas_baricentricas_2(area_total,ax,ay,bx,by,cx,cy,px,py:real;
                                    var alfa,beta,gama:real);

Const pequeno = 0.00001;

Var TP00,TP0x,TP0y:Ponto;
    TVz,TVx,TVy:vetor;
    TemTextura:Boolean;

implementation

procedure mundial_para_vista_1pt(P:Ponto);
var
   x,y,z:real;
begin
   x:=P.xm - Camera1.C.xm;
   y:=P.ym - Camera1.C.ym;
   z:=P.zm*FatorDilatacaoZ - Camera1.C.zm;
   P.x:=x*Camera1.U.x + y*Camera1.U.y + z*Camera1.U.z;
   P.y:=x*Camera1.V.x + y*Camera1.V.y + z*Camera1.V.z;
   P.z:=x*Camera1.N.x + y*Camera1.N.y + z*Camera1.N.z;
end;


procedure mundial_para_vista;
var i:integer;
   x,y,z:real;
begin
   for i:=0 to NPontos-1 do begin
      x:=LPontos[i].xm - Camera1.C.xm;
      y:=LPontos[i].ym - Camera1.C.ym;
      z:=LPontos[i].zm*FatorDilatacaoZ - Camera1.C.zm;
      LPontos[i].x:=x*Camera1.U.x + y*Camera1.U.y + z*Camera1.U.z;
      LPontos[i].y:=x*Camera1.V.x + y*Camera1.V.y + z*Camera1.V.z;
      LPontos[i].z:=x*Camera1.N.x + y*Camera1.N.y + z*Camera1.N.z;
   end;
end;

procedure mundial_para_vista_fontes_de_luz;
var i:integer;
   x,y,z:real;
begin
   for i:=0 to LFontesCont-1 do begin
      x:=LPosicoesDasFontes[i].xm - Camera1.C.xm;
      y:=LPosicoesDasFontes[i].ym - Camera1.C.ym;
      z:=LPosicoesDasFontes[i].zm*FatorDilatacaoZ - Camera1.C.zm;
      LPosicoesDasFontes[i].x:=x*Camera1.U.x + y*Camera1.U.y + z*Camera1.U.z;
      LPosicoesDasFontes[i].y:=x*Camera1.V.x + y*Camera1.V.y + z*Camera1.V.z;
      LPosicoesDasFontes[i].z:=x*Camera1.N.x + y*Camera1.N.y + z*Camera1.N.z;
   end;
end;

procedure mundial_para_vista_textura;
var i:integer;
begin
   if TP00=nil then begin
      TP00:=Ponto.create(0,0,0);
      TP0x:=Ponto.create(0,0,0);
      TP0y:=Ponto.create(0,0,0);
      TVz:=Vetor.create(0,0,1);
      TVx:=Vetor.create(1,0,0);
      TVy:=Vetor.create(0,1,0);
   end;
   TP00.carrega_mundial(0,0,0);
   TP0x.carrega_mundial(LPontos[0].xm,LPontos[0].ym,0);
   TP0y.carrega_mundial(LPontos[0].xm,LPontos[0].ym,0);
   for i:=1 to NPontos-1 do begin
      if LPontos[i].xm>TP0x.xm then TP0x.xm:=LPontos[i].xm
      else if LPontos[i].xm<TP0y.xm then TP0y.xm:=LPontos[i].xm;
      if LPontos[i].ym>TP0y.ym then TP0y.ym:=LPontos[i].ym
      else if LPontos[i].ym<TP0x.ym then TP0x.ym:=LPontos[i].ym;
   end;
   TP00.xm:=TP0y.xm;
   TP00.ym:=TP0x.ym;
   mundial_para_vista_1pt(TP00);
   mundial_para_vista_1pt(TP0x);
   mundial_para_vista_1pt(TP0y);
   TVx.carrega(TP0x,TP00);
   TVy.carrega(TP0y,TP00);
   TVz.carrega(Camera1.U.z,Camera1.V.z,Camera1.N.z); {vetor OZ transformado}
end;

procedure coordenadas_baricentricas(ax,ay,bx,by,cx,cy,px,py:real;
                                    var alfa,beta,gama:real);
var area_total:real;
begin
   area_total:=(ax - cx)*(by - cy) - (ay - cy)*(bx - cx);
   if (abs(area_total)<pequeno) then begin
      alfa:=0; beta:=0;  gama:=0; //tringulo degenerado-> coords invlidas
   end
   else begin
      alfa:=((px - cx)*(by - cy) - (py - cy)*(bx - cx))/area_total;
      beta:=((ax - cx)*(py - cy) - (ay - cy)*(px - cx))/area_total;
      gama:=1 - alfa - beta;
   end;
end;

procedure coordenadas_baricentricas_2(area_total,ax,ay,bx,by,cx,cy,px,py:real;
                                    var alfa,beta,gama:real);
begin
   if (abs(area_total)<pequeno) then begin
      alfa:=0; beta:=0;  gama:=0; //tringulo degenerado-> coords invlidas
   end
   else begin
      alfa:=((px - cx)*(by - cy) - (py - cy)*(bx - cx))/area_total;
      beta:=((ax - cx)*(py - cy) - (ay - cy)*(px - cx))/area_total;
      gama:=1 - alfa - beta;
   end;
end;

end.
