unit uCorte;

interface
uses Classes,Windows,Graphics,ExtCtrls,Forms,SysUtils,Math,uInstrumental_Basico,
uCamera,uTriangulo;


function corte_de_aresta(var x0,y0,x1,y1:real):Boolean;
function corte_aresta_3D(var x0,y0,z0,x1,y1,z1:real):byte;
function corte_triangulo_3D(T:Triangulo; var Kab,Kac,Kbc:real):short;

implementation



function corte_aresta_3D(var x0,y0,z0,x1,y1,z1:real):byte;
var zf:real;
begin
  if (z0<Camera1.d) and (z1<Camera1.d) then result:=0 // nao visivel
  else if (z0>=Camera1.d) and (z1>=Camera1.d) then result:=1// toda visivel
  else if abs(z1-z0)<0.000001 then result:=1
  else if z0<Camera1.d then begin
     zf:=(Camera1.d - z0)/(z1 - z0);
     x0:=x0 + zf*(x1 - x0);
     y0:=y0 + zf*(y1 - y0);
     z0:=Camera1.d;
     result:=2; // cortada pelo z0
  end
  else if z1<Camera1.d then  begin
     zf:=(Camera1.d - z0)/(z1 - z0);
     x1:=x0 + zf*(x1 - x0);
     y1:=y0 + zf*(y1 - y0);
     z1:=Camera1.d;
     result:=3; // cortada pelo z1
  end
end;


function corte_de_aresta(var x0,y0,x1,y1:real):Boolean;
var tmp:real;
    delta:real;
begin
   result:=True;
   if x1 < x0 then begin
      tmp:=x0; x0:=x1; x1:=tmp;
      tmp:=y0; y0:=y1; y1:=tmp;
   end;
// retornar False indica segmento totalmente fora de vista
   if (x0<-1) or (y0<-1) or (x1<-1) or (y1<-1) or (x0>1) or (y0>1)
       or (x1>1) or (y1>1) then begin
       if ((x0<-1) and (x1<-1)) or ((x0>1) and (x1>1))
           or ((y0<-1) and (y1<-1)) or ((y0>1) and (y1>1))then
           result:=False
       else begin
          if (x0=x1)or(y0=y1) then begin
             if x0=x1 then begin
                if y0<-1 then y0:=-1 else if y0>1 then y0:=1;
                if y1<-1 then y1:=-1 else if y1>1 then y1:=1;
             end;
             if y0=y1 then begin
                if x0<-1 then x0:=-1 else if x0>1 then x0:=1;
                if x1<-1 then x1:=-1 else if x1>1 then x1:=1;
             end;
          end
          else begin
             delta:=(y1 - y0)/(x1 - x0);
             if x0<-1 then begin
                y0:= y0 + (-1 - x0)*delta;
                x0:=-1;
             end;
             if x1>1 then begin
                x1:=1;
                y1:= y0 + (1 - x0)*delta;
             end;
             if y0<-1 then begin
                x0:= x0 + (-1 - y0)/delta;
                y0:=-1;
             end
             else if y0>1 then begin
                x0:= x0 + (1 - y0)/delta;
                y0:=1;
             end;
             if y1<-1 then begin
                y1:=-1;
                x1:= x0 + (-1 - y0)/delta;
             end
             else if y1>1 then begin
                y1:=1;
                x1:= x0 + (1 - y0)/delta;
             end;
             if (x0<-1) or (y0<-1) or (x1<-1) or (y1<-1) or (x0>1) or (y0>1)
                or (x1>1) or (y1>1) then result:=False;
          end;
       end;
   end;
end;

function corte_triangulo_3D(T:Triangulo; var Kab,Kac,Kbc:real):short;
begin
   //retorno: -1->triangulo descartado;
   //          0->triangulo sem cortes.
   //                                    no visvel | visvel
   //          1->triangulo com o corte:           A | BC
   //          2->triangulo com o corte:          AB | C
   //          3->triangulo com o corte:          AC | B
   //          4->triangulo com o corte:           B | AC
   //          5->triangulo com o corte:          BC | A
   //          6->triangulo com o corte:           C | AB

   if Abs(LPontos[T.A - 1].z-Camera1.d)<Pequeno then
      LPontos[T.A - 1].z:=LPontos[T.A - 1].z-Pequeno;
   if Abs(LPontos[T.B - 1].z-Camera1.d)<Pequeno then
      LPontos[T.B - 1].z:=LPontos[T.B - 1].z-Pequeno;
   if Abs(LPontos[T.C - 1].z-Camera1.d)<Pequeno then
      LPontos[T.C - 1].z:=LPontos[T.C - 1].z-Pequeno;
   if (LPontos[T.A - 1].z<Camera1.d) and (LPontos[T.B - 1].z<Camera1.d)
      and (LPontos[T.C-1].z<Camera1.d) then result:=-1
   else  if (LPontos[T.A - 1].z>Camera1.d) and (LPontos[T.B - 1].z>Camera1.d)
             and (LPontos[T.C-1].z>Camera1.d) then result:=0
   else  if (LPontos[T.A - 1].z<Camera1.d) and (LPontos[T.B - 1].z>Camera1.d)
             and (LPontos[T.C-1].z>Camera1.d) then begin
            Kab:=(Camera1.d - LPontos[T.A - 1].z)/
                 (LPontos[T.B - 1].z - LPontos[T.A - 1].z);
            Kac:=(Camera1.d - LPontos[T.A - 1].z)/
                 (LPontos[T.C - 1].z - LPontos[T.A - 1].z);
            result:=1;
         end
   else  if (LPontos[T.A - 1].z<Camera1.d) and (LPontos[T.B - 1].z<Camera1.d)
             and (LPontos[T.C-1].z>Camera1.d) then begin
            Kbc:=(Camera1.d - LPontos[T.B - 1].z)/
                 (LPontos[T.C - 1].z - LPontos[T.B - 1].z);
            Kac:=(Camera1.d - LPontos[T.A - 1].z)/
                 (LPontos[T.C - 1].z - LPontos[T.A - 1].z);
            result:=2;
         end
   else  if (LPontos[T.A - 1].z<Camera1.d) and (LPontos[T.B - 1].z>Camera1.d)
             and (LPontos[T.C-1].z<Camera1.d) then begin
            Kab:=(Camera1.d - LPontos[T.A - 1].z)/
                 (LPontos[T.B - 1].z - LPontos[T.A - 1].z);
            Kbc:=(Camera1.d - LPontos[T.B - 1].z)/
                 (LPontos[T.C - 1].z - LPontos[T.B - 1].z);
            result:=3;
          end
   else  if (LPontos[T.A - 1].z>Camera1.d) and (LPontos[T.B - 1].z<Camera1.d)
             and (LPontos[T.C-1].z>Camera1.d) then begin
            Kab:=(Camera1.d - LPontos[T.A - 1].z)/
                 (LPontos[T.B - 1].z - LPontos[T.A - 1].z);
            Kbc:=(Camera1.d - LPontos[T.B - 1].z)/
                 (LPontos[T.C - 1].z - LPontos[T.B - 1].z);
            result:=4;
          end
   else  if (LPontos[T.A - 1].z>Camera1.d) and (LPontos[T.B - 1].z<Camera1.d)
             and (LPontos[T.C-1].z<Camera1.d) then begin
            Kab:=(Camera1.d - LPontos[T.A - 1].z)/
                 (LPontos[T.B - 1].z - LPontos[T.A - 1].z);
            Kac:=(Camera1.d - LPontos[T.A - 1].z)/
                 (LPontos[T.C - 1].z - LPontos[T.A - 1].z);
            result:=5;
         end
   else  if (LPontos[T.A - 1].z>Camera1.d) and (LPontos[T.B - 1].z>Camera1.d)
             and (LPontos[T.C-1].z<Camera1.d) then begin
            Kbc:=(Camera1.d - LPontos[T.B - 1].z)/
                 (LPontos[T.C - 1].z - LPontos[T.B - 1].z);
            Kac:=(Camera1.d - LPontos[T.A - 1].z)/
                 (LPontos[T.C - 1].z - LPontos[T.A - 1].z);
            result:=6;
         end;
end;

end.
