Unit uGouraud;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,Math,
  Dialogs, StdCtrls, ExtCtrls,uInstrumental_Basico,uCamera,uTriangulo,uObjeto,
  uCena,uCorte,uBitMap,uCoordenadas,uZ_buffer;


function gouraud_shading:TBitmap;
function gouraud_shading_zbuffer:TBitmap;


implementation

const PEQUENO=0.9;

procedure prepara_listas_de_cores;
var
    i:integer;
begin
  SetLength(LCores,NPontos);
  for i:=0 to NPontos-1 do
     LCores[i]:=Cor.create(0,0,0);
end;


function scanconvert(x1,y1,x2,y2,x3,y3:integer; R1,G1,B1,R2,G2,B2,R3,G3,B3:real):TBitMap;
var
x,y,xmin,xmax,aux2,aux1,yscan,px,py:integer;
delta12,delta23,delta13,deltaMin,deltaMax:real;
Rxmin,Rxmax:real;
alfa,beta,gama:real;
R,G,B:real;
Red,Green,Blue,ymin,ymax:Integer;

begin
   if not((x1=x2)and(x1=x3)) and not((y1=y2)and(y1=y3)) and
      not((x1<0)and(x2<0)and(x3<0))and not((x1>Largura)and(x2>Largura)and(x3>Largura))
      and not((y1<0)and(y2<0)and(y3<0))and not ((y1>Altura)and(y2>Altura)and(y3>Altura)) then begin
{#################PONTO MAIS ALTO E PONTO INTERMEDIARIO ##################}
      if y2>y1 then begin
         aux1 := x1;
         aux2 := y1;
         y1 := y2;
         x1 := x2;
         y2 := aux2;
         x2 := aux1;
         R:=R1; G:=G1; B:=B1;
         R1:=R2; G1:=G2; B1:=B2;
         R2:=R;  G2:=G;  B2:=B;
      end;
      if y3>y1 then begin
         aux1 := x1;
         aux2 := y1;
         y1 := y3;
         x1 := x3;
         y3 := aux2;
         x3 := aux1;
         R:=R1; G:=G1; B:=B1;
         R1:=R3; G1:=G3; B1:=B3;
         R3:=R;  G3:=G;  B3:=B;
      end;

{###################PONTO MAIS BAIXO########################################}

      if y3>y2 then begin
         aux1 := x2;
         aux2 := y2;
         y2 := y3;
         x2 := x3;
         y3 := aux2;
         x3 := aux1;
         R:=R3; G:=G3; B:=B3;
         R3:=R2; G3:=G2; B3:=B2;
         R2:=R;  G2:=G;  B2:=B;
      end;

{###################CALCULO DOS DELTAS INVERSOS################################}
      if y1=y2 then
         delta12:=0
      else
         delta12:= (x2-x1)/(y1-y2);
      if y2=y3 then
         delta23:=0
      else
         delta23:= (x3-x2)/(y2-y3);
      delta13:= (x3-x1)/(y1-y3);

{***********************CALCULO DAS CORES*********************************}


{###################ASSOCIAO DOS DELTAS###################################}

      if{abs(delta12)<PEQUENO} y1=y2 then begin
         deltaMin:=delta13;
         deltaMax:=delta23;
         xmin:=x1;
         xmax:=x2;
         if delta13<delta23 then begin
            deltaMin:=delta23;
            deltaMax:=delta13;
            xmin:=x2;
            xmax:=x1;
         end;
         ymin:=y3;
         ymax:=y1;
         Rxmin := xmin;
         Rxmax := xmax;
         if ymax>Altura-1 then begin
            ymax:=Altura-1;
            Rxmin:=-deltaMin*(Altura-1-ymax)+xmin;
            Rxmax:=-deltaMax*(Altura-1-ymax)+xmax;
         end;
         if ymin<0 then ymin:=0;
         xmin:=round(Rxmin);
         xmax:=round(Rxmax);
         if xmin<0 then xmin:=0;
         if xmax>Largura-1 then xmax:=Largura-1;
         for yscan:=ymax downto ymin do begin
            py:=yscan;
            for x:=xmin to xmax do begin
               px:=x;
               coordenadas_baricentricas(x1,y1,x2,y2,x3,y3,px,py,alfa,beta,gama);
               if (alfa>=0)and(beta>=0)and(gama>=0)then begin
                  Red:=  trunc(alfa*R1 + beta*R2 + gama*R3);
                  Green:=trunc(alfa*G1 + beta*G2 + gama*G3);
                  Blue:= trunc(alfa*B1 + beta*B2 + gama*B3);
                  Bitmap.Canvas.Pixels[x,Altura-yscan] := RGB(Red,Green,Blue);
               end;
            end;
            Rxmin:=Rxmin+deltaMin;
            Rxmax:=Rxmax+deltaMax;
            xmin:= trunc(Rxmin+0.5);
            xmax:= trunc(Rxmax+0.5);
            if xmin<0 then xmin:=0;
            if xmax>Largura-1 then xmax:=Largura-1;
         end;
       end
       else begin
         deltaMin:=delta12;
         deltaMax:=delta13;
         if delta13<delta12 then begin
            deltaMin:=delta13;
            deltaMax:=delta12;
         end;
         Rxmin := x1;
         Rxmax := x1;
         ymin:=y2;
         ymax:=y1;
         if ymax>Altura-1 then begin
            ymax:=Altura-1;
            Rxmin:=-deltaMin*(Altura-1-y1)+x1;
            Rxmax:=-deltaMax*(Altura-1-y1)+x1;
         end;
         if ymin<0 then ymin:=0;
         xmin:=round(Rxmin);
         xmax:=round(Rxmax);
         if xmin<0 then xmin:=0;
         if xmax>Largura-1 then xmax:=Largura-1;
         for yscan:=ymax downto ymin do begin
            py:=yscan;
            for x:=xmin to xmax do begin
               px:=x;
               coordenadas_baricentricas(x1,y1,x2,y2,x3,y3,px,py,alfa,beta,gama);
               if (alfa>=0)and(beta>=0)and(gama>=0)then begin
                  Red:=  trunc(alfa*R1 + beta*R2 + gama*R3);
                  Green:=trunc(alfa*G1 + beta*G2 + gama*G3);
                  Blue:= trunc(alfa*B1 + beta*B2 + gama*B3);
                  Bitmap.Canvas.Pixels[x,Altura-yscan] := RGB(Red,Green,Blue);
               end;
           end;
           Rxmin:=Rxmin+deltaMin;
           Rxmax:=Rxmax+deltaMax;
           xmin:= trunc(Rxmin+0.5);
           xmax:= trunc(Rxmax+0.5);
           if xmin<0 then xmin:=0;
           if xmax>Largura-1 then xmax:=Largura-1;
         end;
         Rxmin:=Rxmin-deltaMin;
         Rxmax:=Rxmax-deltaMax;
         if y2<>y3 then begin
            deltaMin:=delta13;
            deltaMax:=delta23;
            if delta13<delta23 then begin
               deltaMin:=delta23;
               deltaMax:=delta13;
            end;
            ymin:=y3;
            ymax:=y2;
            if ymax>Altura-1 then begin
               ymax:=Altura-1;
               if delta13>delta23 then begin
                  Rxmin:=-deltaMin*(Altura-1-y1)+x1;
                  Rxmax:=-deltaMax*(Altura-1-y2)+x2;
               end
               else begin
                  Rxmin:=-deltaMin*(Altura-1-y2)+x2;
                  Rxmax:=-deltaMax*(Altura-1-y1)+x1;
               end;
            end;
            xmin:=round(Rxmin);
            xmax:=round(Rxmax);
            if xmin<0 then xmin:=0;
            if xmax>Largura-1 then xmax:=Largura-1;
            if ymin<0 then ymin:=0;
            for yscan:=ymax downto ymin do begin
               py:=yscan;
               for x:=xmin to xmax do begin
                  px:=x;
                  coordenadas_baricentricas(x1,y1,x2,y2,x3,y3,px,py,alfa,beta,gama);
                  if (alfa>=0)and(beta>=0)and(gama>=0)then begin
                     Red:=  trunc(alfa*R1 + beta*R2 + gama*R3);
                     Green:=trunc(alfa*G1 + beta*G2 + gama*G3);
                     Blue:= trunc(alfa*B1 + beta*B2 + gama*B3);
                     Bitmap.Canvas.Pixels[x,Altura-yscan] := RGB(Red,Green,Blue);
                  end;
               end;
               Rxmin:=Rxmin+deltaMin;
               Rxmax:=Rxmax+deltaMax;
               xmin:= trunc(Rxmin+0.5);
               xmax:= trunc(Rxmax+0.5);
               if xmin<0 then xmin:=0;
               if xmax>Largura-1 then xmax:=Largura-1;
            end;
         end;
       end;
   end;
   scanconvert:=BitMap;
 end;


function scanconvert_zbuffer( xv1,yv1,zv1,xv2,yv2,zv2,xv3,yv3,zv3:real;
                           R1,G1,B1,R2,G2,B2,R3,G3,B3:real; N:vetor):TBitMap;
var
   x,y,xmin,xmax,ymin,ymax,aux2,aux1,yscan,x1,y1,x2,y2,x3,y3:integer;
   delta12,delta23,delta13,deltaMin,deltaMax,t,t_numerador:real;
   Rxmin,Rxmax,px,py,alfa,beta,gama,z,xr,xb,dx,area,toler:real;
   Red,Green,Blue:Integer;

begin
   x1:=round( (Camera1.d*xv1/(Camera1.hx*zv1) + 1)* meia_largura );
   y1:=round( (Camera1.d*yv1/(Camera1.hy*zv1) + 1)* meia_altura );
   x2:=round( (Camera1.d*xv2/(Camera1.hx*zv2) + 1)* meia_largura );
   y2:=round( (Camera1.d*yv2/(Camera1.hy*zv2) + 1)* meia_altura );
   x3:=round( (Camera1.d*xv3/(Camera1.hx*zv3) + 1)* meia_largura );
   y3:=round( (Camera1.d*yv3/(Camera1.hy*zv3) + 1)* meia_altura );
   if not((x1=x2)and(x1=x3)) and not((y1=y2)and(y1=y3)) and
      not((x1<0)and(x2<0)and(x3<0))and not((x1>Largura)and(x2>Largura)and(x3>Largura))
      and not((y1<0)and(y2<0)and(y3<0))and not ((y1>Altura)and(y2>Altura)and(y3>Altura)) then begin
      {#################PONTO MAIS ALTO E PONTO INTERMEDIARIO ##################}
      t_numerador:=xv3*N.x + yv3*N.y + zv3*N.z;
      area:=(xv1 - xv3)*(yv2 - yv3) - (yv1 - yv3)*(xv2 - xv3);
     { toler:=0.1/Math.Power(abs(area),0.1);}
     toler:=0;
      if y2>y1 then begin
         aux1 := x1;
         aux2 := y1;
         y1 := y2;
         x1 := x2;
         y2 := aux2;
         x2 := aux1;
      end;
      if y3>y1 then begin
         aux1 := x1;
         aux2 := y1;
         y1 := y3;
         x1 := x3;
         y3 := aux2;
         x3 := aux1;
      end;

      {###################PONTO MAIS BAIXO########################################}

      if y3>y2 then begin
         aux1 := x2;
         aux2 := y2;
         y2 := y3;
         x2 := x3;
         y3 := aux2;
         x3 := aux1;
      end;

     {###################CALCULO DOS DELTAS INVERSOS################################}
      if y1=y2 then
         delta12:=0
      else
         delta12:= (x2-x1)/(y1-y2);
      if y2=y3 then
         delta23:=0
      else
         delta23:= (x3-x2)/(y2-y3);
      delta13:= (x3-x1)/(y1-y3);

{***********************CALCULO DAS CORES*********************************}


{###################ASSOCIAO DOS DELTAS###################################}


      if{abs(delta12)<PEQUENO} y1=y2 then begin
         deltaMin:=delta13;
         deltaMax:=delta23;
         xmin:=x1;
         xmax:=x2;
         if delta13<delta23 then begin
            deltaMin:=delta23;
            deltaMax:=delta13;
            xmin:=x2;
            xmax:=x1;
         end;
         ymin:=y3;
         ymax:=y1;
         Rxmin := xmin;
         Rxmax := xmax;
         if ymax>Altura-1 then begin
            ymax:=Altura-1;
            Rxmin:=-deltaMin*(Altura-1-ymax)+xmin;
            Rxmax:=-deltaMax*(Altura-1-ymax)+xmax;
         end;
         if ymin<0 then ymin:=0;
         xmin:=round(Rxmin);
         xmax:=round(Rxmax);
         if xmin<0 then xmin:=0;
         if xmax>Largura-1 then xmax:=Largura-1;
         for yscan:=ymax downto ymin do begin
            py:=(yscan/meia_altura - 1)*Camera1.hy;
            xr:=Rxmin - xmin;
            xb:=Rxmax - xmax;
            if xmin=xmax then dx:=0
            else dx:=(xb - xr)/(xmax - xmin);
            for x:=xmin to xmax do begin
               px:=((x+xr+(x-xmin)*dx)/meia_largura - 1)*Camera1.hx;
               t:=t_numerador/(px*N.x + py*N.y + Camera1.d*N.z);
               coordenadas_baricentricas_2(area,xv1,yv1,xv2,yv2,xv3,yv3,t*px,t*py,alfa,beta,gama);
               if ((alfa>0)or(abs(alfa)<PEQUENO))and((beta>0)or(abs(beta)<PEQUENO))
                   and ((gama>0)or(abs(gama)<PEQUENO)) then begin
                  z:=alfa*zv1 + beta*zv2 + gama*zv3;
                  if (z < z_buffer.pixel[x,yscan]) then begin
                     z_buffer.pixel[x,yscan]:=z;
                     if (abs(alfa)<toler)or(abs(beta)<toler) or
                        (abs(gama)<toler) then begin
                           Red:=255; Green:=255; Blue:=0;
                     end
                     else begin
                        Red:=  trunc(alfa*R1 + beta*R2 + gama*R3);
                        Green:=trunc(alfa*G1 + beta*G2 + gama*G3);
                        Blue:= trunc(alfa*B1 + beta*B2 + gama*B3);
                        if Red<0 then Red:=0 else if Red>255 then Red:=255;
                        if Green<0 then Green:=0 else if Green>255 then Green:=255;
                        if Blue<0 then Blue:=0 else if Blue>255 then Blue:=255;
                     end;
                     Bitmap.Canvas.Pixels[x,Altura-yscan] := RGB(Red,Green,Blue);
                  end;
               end;
            end;
            Rxmin:=Rxmin+deltaMin;
            Rxmax:=Rxmax+deltaMax;
            xmin:= round(Rxmin);
            xmax:= round(Rxmax);
            if xmin<0 then xmin:=0;
            if xmax>Largura-1 then xmax:=Largura-1;
         end;
       end
       else begin
         deltaMin:=delta12;
         deltaMax:=delta13;
         if delta13<delta12 then begin
            deltaMin:=delta13;
            deltaMax:=delta12;
         end;
         Rxmin := x1;
         Rxmax := x1;
         ymin:=y2;
         ymax:=y1;
         if ymax>Altura-1 then begin
            ymax:=Altura-1;
            Rxmin:=-deltaMin*(Altura-1-y1)+x1;
            Rxmax:=-deltaMax*(Altura-1-y1)+x1;
         end;
         if ymin<0 then ymin:=0;
         xmin:=round(Rxmin);
         xmax:=round(Rxmax);
         if xmin<0 then xmin:=0;
         if xmax>Largura-1 then xmax:=Largura-1;
         for yscan:=ymax downto ymin do begin
            py:=(yscan/meia_altura - 1)*Camera1.hy;
            xr:=Rxmin - xmin;
            xb:=Rxmax - xmax;
            if xmin=xmax then dx:=0
            else dx:=(xb - xr)/(xmax - xmin);
            for x:=xmin to xmax do begin
                px:=((x+xr+(x-xmin)*dx)/meia_largura - 1)*Camera1.hx;
               t:=t_numerador/(px*N.x + py*N.y + Camera1.d*N.z);
               coordenadas_baricentricas_2(area,xv1,yv1,xv2,yv2,xv3,yv3,t*px,t*py,alfa,beta,gama);
               if ((alfa>0)or(abs(alfa)<PEQUENO))and((beta>0)or(abs(beta)<PEQUENO))
                   and ((gama>0)or(abs(gama)<PEQUENO)) then  begin
                  z:=alfa*zv1 + beta*zv2 + gama*zv3;
                  if (z < z_buffer.pixel[x,yscan]) then begin
                     z_buffer.pixel[x,yscan]:=z;
                     if (abs(alfa)<toler)or(abs(beta)<toler) or
                        (abs(gama)<toler) then begin
                           Red:=255; Green:=255; Blue:=0;
                     end
                     else begin
                        Red:=  trunc(alfa*R1 + beta*R2 + gama*R3);
                        Green:=trunc(alfa*G1 + beta*G2 + gama*G3);
                        Blue:= trunc(alfa*B1 + beta*B2 + gama*B3);
                        if Red<0 then Red:=0 else if Red>255 then Red:=255;
                        if Green<0 then Green:=0 else if Green>255 then Green:=255;
                        if Blue<0 then Blue:=0 else if Blue>255 then Blue:=255;
                     end;
                     Bitmap.Canvas.Pixels[x,Altura-yscan] := RGB(Red,Green,Blue);
                  end;
               end;
          end;
           Rxmin:=Rxmin+deltaMin;
           Rxmax:=Rxmax+deltaMax;
           xmin:= round(Rxmin);
           xmax:= round(Rxmax);
           if xmin<0 then xmin:=0;
           if xmax>Largura-1 then xmax:=Largura-1;
         end;
         Rxmin:=Rxmin-deltaMin;
         Rxmax:=Rxmax-deltaMax;
         if y2<>y3 then begin
            deltaMin:=delta13;
            deltaMax:=delta23;
            if delta13<delta23 then begin
               deltaMin:=delta23;
               deltaMax:=delta13;
            end;
            ymin:=y3;
            ymax:=y2;
            if ymax>Altura-1 then begin
               ymax:=Altura-1;
               if delta13>delta23 then begin
                  Rxmin:=-deltaMin*(Altura-1-y1)+x1;
                  Rxmax:=-deltaMax*(Altura-1-y2)+x2;
               end
               else begin
                  Rxmin:=-deltaMin*(Altura-1-y2)+x2;
                  Rxmax:=-deltaMax*(Altura-1-y1)+x1;
               end;
            end;
            xmin:=round(Rxmin);
            xmax:=round(Rxmax);
            if xmin<0 then xmin:=0;
            if xmax>Largura-1 then xmax:=Largura-1;
            if ymin<0 then ymin:=0;
            for yscan:=ymax downto ymin do begin
               py:=(yscan/meia_altura - 1)*Camera1.hy;
               xr:=Rxmin - xmin;
               xb:=Rxmax - xmax;
               if xmin=xmax then dx:=0
               else dx:=(xb - xr)/(xmax - xmin);
               for x:=xmin to xmax do begin
                  px:=((x+xr+(x-xmin)*dx)/meia_largura - 1)*Camera1.hx;
                  t:=t_numerador/(px*N.x + py*N.y + Camera1.d*N.z);
                  coordenadas_baricentricas_2(area,xv1,yv1,xv2,yv2,xv3,yv3,t*px,t*py,alfa,beta,gama);
                  if ((alfa>0)or(abs(alfa)<PEQUENO))and((beta>0)or(abs(beta)<PEQUENO))
                      and ((gama>0)or(abs(gama)<PEQUENO)) then begin
                     z:=alfa*zv1 + beta*zv2 + gama*zv3;
                     if (z < z_buffer.pixel[x,yscan]) then begin
                        z_buffer.pixel[x,yscan]:=z;
                     if (abs(alfa)<toler)or(abs(beta)<toler) or
                        (abs(gama)<toler) then begin
                           Red:=255; Green:=255; Blue:=0;
                     end
                     else begin
                        Red:=  trunc(alfa*R1 + beta*R2 + gama*R3);
                        Green:=trunc(alfa*G1 + beta*G2 + gama*G3);
                        Blue:= trunc(alfa*B1 + beta*B2 + gama*B3);
                        if Red<0 then Red:=0 else if Red>255 then Red:=255;
                        if Green<0 then Green:=0 else if Green>255 then Green:=255;
                        if Blue<0 then Blue:=0 else if Blue>255 then Blue:=255;
                     end;
                        Bitmap.Canvas.Pixels[x,Altura-yscan] := RGB(Red,Green,Blue);
                     end;
                  end;
               end;
               Rxmin:=Rxmin+deltaMin;
               Rxmax:=Rxmax+deltaMax;
               xmin:= round(Rxmin);
               xmax:= round(Rxmax);
               if xmin<0 then xmin:=0;
               if xmax>Largura-1 then xmax:=Largura-1;
            end;
         end;
       end;
   end;
   scanconvert_zbuffer:=BitMap;
 end;

procedure computa_cor_no_vertice(var I:Cor; Caux,Id,Isp,Ospc,Odif:Cor;
                                 N,L,R,V:vetor;P:ponto);
var
    N_escalar_L,V_escalar_R:real;
    Li:integer;
begin
   Id.carrega(0,0,0);
   Isp.carrega(0,0,0);
   V.vetor_terminado_no_ponto(P);
   V.simetrico;
   V.normalizado;
   if V.escalar(N)<0 then begin
      Odif.copia(Odi);
      Ospc.copia(Osi);
      N.simetrico;
   end
   else begin
      Odif.copia(Ode);
      Ospc.copia(Ose);
   end;
   Odif.vezes(Kd);
   Ospc.vezes(Ks);
   Odif.normalizada;
   Ospc.normalizada;
   I.copia(Ia);
   I.vezes(Ka);
   for Li:=0 to LFontesCont-1 do begin
      L.carrega(LPosicoesDasFontes[Li],P);
      if N.escalar(L)>0 then begin
         L.normalizado;
         N_escalar_L:=N.escalar(L);
         produto(Caux,N_escalar_L,Odif,LCoresDasFontes[Li]);
         Id.mais(Caux);
         if Ks>0 then begin
            R.copia(N);
            R.vezes(2*N_escalar_L);
            R.menos(L);
            V_escalar_R:=V.escalar(R);
            if V_escalar_R>0 then begin
               V_escalar_R:=Math.Power(V_escalar_R,rugosidade);
               produto(Caux,V_escalar_R,Ospc,LCoresDasFontes[Li]);
               Isp.mais(Caux);
            end;
         end;
      end;
   end;
   I.mais(Id);
   I.mais(Isp);
   I.truncada;
end;

procedure computa_cores_nos_vertices;
var
    I0,I1,I2,Id,Isp,Odif,Ospc,Caux:Cor;
    L,V,R:vetor;
    i:integer;
begin
   I0:=Cor.create(0,0,0);
   I1:=Cor.create(0,0,0);
   I2:=Cor.create(0,0,0);
   Caux:=Cor.create(0,0,0);
   Id:=Cor.create(0,0,0);
   Isp:=Cor.create(0,0,0);
   Ospc:=Cor.create(0,0,0);
   Odif:=Cor.create(0,0,0);
   L:=vetor.create(0,0,0);
   R:=vetor.create(0,0,0);
   V:=vetor.create(0,0,0);
   for i:=0 to NPontos-1 do
      computa_cor_no_vertice(LCores[i],Caux,Id,Isp,Ospc,Odif,LNormais[i],L,R,V,LPontos[i]);
   Caux.Free;
   I0.Free;
   I1.Free;
   I2.Free;
   Id.Free;
   Isp.Free;
   Ospc.Free;
   Odif.Free;
   L.Free;
   R.Free;
   V.Free;
end;

procedure ilumina_triangulo_gouraud(xv0,yv0,zv0,xv1,yv1,zv1,xv2,yv2,zv2:real;
                                    I0,I1,I2:cor);
begin
   xv0:=Camera1.d*xv0/(Camera1.hx*zv0);
   yv0:=Camera1.d*yv0/(Camera1.hy*zv0);
   xv1:=Camera1.d*xv1/(Camera1.hx*zv1);
   yv1:=Camera1.d*yv1/(Camera1.hy*zv1);
   xv2:=Camera1.d*xv2/(Camera1.hx*zv2);
   yv2:=Camera1.d*yv2/(Camera1.hy*zv2);
   BitMap:=scanconvert(round((xv0+1)*meia_largura),round((yv0+1)*meia_altura),
               round((xv1+1)*meia_largura),round((yv1+1)*meia_altura),
               round((xv2+1)*meia_largura),round((yv2+1)*meia_altura),
               I0.r,I0.g,I0.b,I1.r,I1.g,I1.b,I2.r,I2.g,I2.b);
end;


procedure ilumina_triangulo_gouraud_zbuffer(xv0,yv0,zv0,xv1,yv1,zv1,xv2,yv2,zv2:real;
                                    I0,I1,I2:cor; N:vetor);
begin
   BitMap:=scanconvert_zbuffer(xv0,yv0,zv0,xv1,yv1,zv1,xv2,yv2,zv2,
                              I0.r,I0.g,I0.b,I1.r,I1.g,I1.b,I2.r,I2.g,I2.b,N);
end;



function gouraud_shading_zbuffer:TBitmap;
var i,k,A,B,C:integer;
    T:Triangulo;
    N:vetor;
    corte:short;
    Vtmp:vetor;
    Kab,Kac,Kbc,xc0,yc0,xc1,yc1:real;
    C0,C1:Cor;
begin
   Bitmap.Canvas.Pen.Color:=RGB(0,0,0);//RGB(255,255,0);
   Vtmp:=vetor.create(0,0,0);
   C0:=Cor.create(0,0,0);
   C1:=Cor.create(0,0,0);
   Bitmap.Canvas.Brush.Color:=RGB(255,255,255);//RGB(0,0,0);

   Bitmap.Canvas.Rectangle(1,1,Largura,Altura);
   obter_distancias;
   LTriangulos.Sort(compare);
   for i:=LTriangulos.Count-1 downto 0 do begin
      T:=LTriangulos[i];
      T.computa_normal(LPontos,Vtmp);
   end;
   prepara_listas_de_normais;
   computa_normais_nos_pontos;
   prepara_listas_de_cores;
   computa_cores_nos_vertices;

   for i:=0 to LTriangulos.Count-1 do begin
      T:=LTriangulos[i];
      A:=T.A - 1;
      B:=T.B - 1;
      C:=T.C - 1;
      N:=T.Normal;
      corte:=corte_triangulo_3D(T,Kab,Kac,Kbc);
      if corte>=0 then begin
         case corte of
            0:ilumina_triangulo_gouraud_zbuffer(LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                    LCores[A],LCores[B],LCores[C],N);
            1:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc1:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 C0.carrega(LCores[A].r + Kab*(LCores[B].r - LCores[A].r),
                            LCores[A].g + Kab*(LCores[B].g - LCores[A].g),
                            LCores[A].b + Kab*(LCores[B].b - LCores[A].b));
                 C1.carrega(LCores[A].r + Kac*(LCores[C].r - LCores[A].r),
                            LCores[A].g + Kac*(LCores[C].g - LCores[A].g),
                            LCores[A].b + Kac*(LCores[C].b - LCores[A].b));
                 ilumina_triangulo_gouraud_zbuffer(LPontos[B].x,LPontos[B].y,LPontos[B].z,
                             xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,LCores[B],C0,C1,N);
                 ilumina_triangulo_gouraud_zbuffer(LPontos[B].x,LPontos[B].y,LPontos[B].z,
                             LPontos[C].x,LPontos[C].y,LPontos[C].z,
                             xc1,yc1,Camera1.d,LCores[B],LCores[C],C1,N);

              end;
            2:begin
                 xc0:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 C0.carrega(LCores[A].r + Kac*(LCores[C].r - LCores[A].r),
                            LCores[A].g + Kac*(LCores[C].g - LCores[A].g),
                            LCores[A].b + Kac*(LCores[C].b - LCores[A].b));
                 C1.carrega(LCores[B].r + Kbc*(LCores[C].r - LCores[B].r),
                            LCores[B].g + Kbc*(LCores[C].g - LCores[B].g),
                            LCores[B].b + Kbc*(LCores[C].b - LCores[B].b));
                 ilumina_triangulo_gouraud_zbuffer(xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                    C0,C1,LCores[C],N);
               end;
            3:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 C0.carrega(LCores[A].r + Kab*(LCores[B].r - LCores[A].r),
                            LCores[A].g + Kab*(LCores[B].g - LCores[A].g),
                            LCores[A].b + Kab*(LCores[B].b - LCores[A].b));
                 C1.carrega(LCores[B].r + Kbc*(LCores[C].r - LCores[B].r),
                            LCores[B].g + Kbc*(LCores[C].g - LCores[B].g),
                            LCores[B].b + Kbc*(LCores[C].b - LCores[B].b));
                 ilumina_triangulo_gouraud_zbuffer(xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                    C0,C1,LCores[B],N);
               end;
            4:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 C0.carrega(LCores[A].r + Kab*(LCores[B].r - LCores[A].r),
                            LCores[A].g + Kab*(LCores[B].g - LCores[A].g),
                            LCores[A].b + Kab*(LCores[B].b - LCores[A].b));
                 C1.carrega(LCores[B].r + Kbc*(LCores[C].r - LCores[B].r),
                            LCores[B].g + Kbc*(LCores[C].g - LCores[B].g),
                            LCores[B].b + Kbc*(LCores[C].b - LCores[B].b));

                 ilumina_triangulo_gouraud_zbuffer(xc0,yc0,Camera1.d,
                                    LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                    C0,LCores[A],LCores[C],N);
                 ilumina_triangulo_gouraud_zbuffer(xc0,yc0,Camera1.d,
                                    xc1,yc1,Camera1.d,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                    C0,C1,LCores[C],N);
              end;
            5:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc1:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 C0.carrega(LCores[A].r + Kab*(LCores[B].r - LCores[A].r),
                            LCores[A].g + Kab*(LCores[B].g - LCores[A].g),
                            LCores[A].b + Kab*(LCores[B].b - LCores[A].b));
                 C1.carrega(LCores[A].r + Kac*(LCores[C].r - LCores[A].r),
                            LCores[A].g + Kac*(LCores[C].g - LCores[A].g),
                            LCores[A].b + Kac*(LCores[C].b - LCores[A].b));
                 ilumina_triangulo_gouraud_zbuffer(xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                    LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    C0,C1,LCores[A],N);
               end;
            6:begin
                 xc0:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 C0.carrega(LCores[A].r + Kac*(LCores[C].r - LCores[A].r),
                            LCores[A].g + Kac*(LCores[C].g - LCores[A].g),
                            LCores[A].b + Kac*(LCores[C].b - LCores[A].b));
                 C1.carrega(LCores[B].r + Kbc*(LCores[C].r - LCores[B].r),
                            LCores[B].g + Kbc*(LCores[C].g - LCores[B].g),
                            LCores[B].b + Kbc*(LCores[C].b - LCores[B].b));

                 ilumina_triangulo_gouraud_zbuffer(xc0,yc0,Camera1.d,
                                    LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                    C0,LCores[A],LCores[B],N);
                 ilumina_triangulo_gouraud_zbuffer(xc0,yc0,Camera1.d,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                     xc1,yc1,Camera1.d,
                                    C0,LCores[B],C1,N);
              end;
         end;
      end;
   end;
   Vtmp.Free;
   C0.Free;
   C1.Free;
   result:=Bitmap;
end;


function gouraud_shading:TBitmap;
var i,k,A,B,C:integer;
    T:Triangulo;
    corte:short;
    Vtmp:vetor;
    Kab,Kac,Kbc,xc0,yc0,xc1,yc1:real;
    C0,C1:Cor;
begin

   Bitmap.Canvas.Pen.Color:=RGB(255,255,0);
   Vtmp:=vetor.create(0,0,0);
   C0:=Cor.create(0,0,0);
   C1:=Cor.create(0,0,0);
   Bitmap.Canvas.Brush.Color:=RGB(0,0,0);
   Bitmap.Canvas.Rectangle(1,1,Largura,Altura);
   obter_distancias;
   LTriangulos.Sort(compare);
   for i:=LTriangulos.Count-1 downto 0 do begin
      T:=LTriangulos[i];
      T.computa_normal(LPontos,Vtmp);
   end;
   prepara_listas_de_normais;
   computa_normais_nos_pontos;
   prepara_listas_de_cores;
   computa_cores_nos_vertices;

   for i:=LTriangulos.Count-1 downto 0 do begin
      T:=LTriangulos[i];
      A:=T.A - 1;
      B:=T.B - 1;
      C:=T.C - 1;
      corte:=corte_triangulo_3D(T,Kab,Kac,Kbc);
      if corte>=0 then begin
         case corte of
            0:ilumina_triangulo_gouraud(LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                    LCores[A],LCores[B],LCores[C]);
            1:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc1:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 C0.carrega(LCores[A].r + Kab*(LCores[B].r - LCores[A].r),
                            LCores[A].g + Kab*(LCores[B].g - LCores[A].g),
                            LCores[A].b + Kab*(LCores[B].b - LCores[A].b));
                 C1.carrega(LCores[A].r + Kac*(LCores[C].r - LCores[A].r),
                            LCores[A].g + Kac*(LCores[C].g - LCores[A].g),
                            LCores[A].b + Kac*(LCores[C].b - LCores[A].b));
                 ilumina_triangulo_gouraud(LPontos[B].x,LPontos[B].y,LPontos[B].z,
                             xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,LCores[B],C0,C1);
                 ilumina_triangulo_gouraud(LPontos[B].x,LPontos[B].y,LPontos[B].z,
                             LPontos[C].x,LPontos[C].y,LPontos[C].z,
                             xc1,yc1,Camera1.d,LCores[B],LCores[C],C1);

              end;
            2:begin
                 xc0:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 C0.carrega(LCores[A].r + Kac*(LCores[C].r - LCores[A].r),
                            LCores[A].g + Kac*(LCores[C].g - LCores[A].g),
                            LCores[A].b + Kac*(LCores[C].b - LCores[A].b));
                 C1.carrega(LCores[B].r + Kbc*(LCores[C].r - LCores[B].r),
                            LCores[B].g + Kbc*(LCores[C].g - LCores[B].g),
                            LCores[B].b + Kbc*(LCores[C].b - LCores[B].b));
                 ilumina_triangulo_gouraud(xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                    C0,C1,LCores[C]);
               end;
            3:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 C0.carrega(LCores[A].r + Kab*(LCores[B].r - LCores[A].r),
                            LCores[A].g + Kab*(LCores[B].g - LCores[A].g),
                            LCores[A].b + Kab*(LCores[B].b - LCores[A].b));
                 C1.carrega(LCores[B].r + Kbc*(LCores[C].r - LCores[B].r),
                            LCores[B].g + Kbc*(LCores[C].g - LCores[B].g),
                            LCores[B].b + Kbc*(LCores[C].b - LCores[B].b));
                 ilumina_triangulo_gouraud(xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                    C0,C1,LCores[B]);
               end;
            4:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 C0.carrega(LCores[A].r + Kab*(LCores[B].r - LCores[A].r),
                            LCores[A].g + Kab*(LCores[B].g - LCores[A].g),
                            LCores[A].b + Kab*(LCores[B].b - LCores[A].b));
                 C1.carrega(LCores[B].r + Kbc*(LCores[C].r - LCores[B].r),
                            LCores[B].g + Kbc*(LCores[C].g - LCores[B].g),
                            LCores[B].b + Kbc*(LCores[C].b - LCores[B].b));

                 ilumina_triangulo_gouraud(xc0,yc0,Camera1.d,
                                    LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                    C0,LCores[A],LCores[C]);
                 ilumina_triangulo_gouraud(xc0,yc0,Camera1.d,
                                    xc1,yc1,Camera1.d,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                    C0,C1,LCores[C]);
              end;
            5:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc1:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 C0.carrega(LCores[A].r + Kab*(LCores[B].r - LCores[A].r),
                            LCores[A].g + Kab*(LCores[B].g - LCores[A].g),
                            LCores[A].b + Kab*(LCores[B].b - LCores[A].b));
                 C1.carrega(LCores[A].r + Kac*(LCores[C].r - LCores[A].r),
                            LCores[A].g + Kac*(LCores[C].g - LCores[A].g),
                            LCores[A].b + Kac*(LCores[C].b - LCores[A].b));
                 ilumina_triangulo_gouraud(xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                    LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    C0,C1,LCores[A]);
               end;
            6:begin
                 xc0:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 C0.carrega(LCores[A].r + Kac*(LCores[C].r - LCores[A].r),
                            LCores[A].g + Kac*(LCores[C].g - LCores[A].g),
                            LCores[A].b + Kac*(LCores[C].b - LCores[A].b));
                 C1.carrega(LCores[B].r + Kbc*(LCores[C].r - LCores[B].r),
                            LCores[B].g + Kbc*(LCores[C].g - LCores[B].g),
                            LCores[B].b + Kbc*(LCores[C].b - LCores[B].b));

                 ilumina_triangulo_gouraud(xc0,yc0,Camera1.d,
                                    LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                    C0,LCores[A],LCores[B]);
                 ilumina_triangulo_gouraud(xc0,yc0,Camera1.d,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                     xc1,yc1,Camera1.d,
                                    C0,LCores[B],C1);
              end;
         end;
      end;
   end;
   Vtmp.Free;
   C0.Free;
   C1.Free;
   result:=Bitmap;
end;


end.





