unit uObjeto;

interface
uses Classes,Windows,Graphics,ExtCtrls,Forms,SysUtils,Math,uInstrumental_Basico,
uTriangulo;



function carrega_objeto(NomeArq:string):string;
function prepara_objeto(strOdir,strOdig,strOdib,strOder,strOdeg,strOdeb,
                        strOsir,strOsig,strOsib,strOser,strOseg,strOseb,strkd,
                        strks,strn:string):string;

Var
    Odi,Ode,Osi,Ose:Cor;
    kd,ks,rugosidade:real;
    
    ArquivoDoObjeto:Text;
    Centro:Ponto;


implementation


function carrega_objeto(NomeArq:string):string;
var i,j,A,B,C:integer;
    x,y,z:real;
    Tri:Triangulo;
begin
   DecimalSeparator:='.';
   AssignFile(ArquivoDoObjeto,NomeArq);
   {$I-}
   Reset(ArquivoDoObjeto);
   if IOResult<>0 then begin
      result:='Erro na Abertura do Arquivo';
      CloseFile(ArquivoDoObjeto);
   end
   else begin
      read(ArquivoDoObjeto,NPontosAux,NTriangulosAux);
      if (IOResult<>0)or(eof(ArquivoDoObjeto)) then begin
         result:='Arquivo com problemas.';
         CloseFile(ArquivoDoObjeto);
      end
      else begin
         if (NPontosAux<3) or (NTriangulosAux=0) then begin
            result:='Objeto sem faces para serem mostradas.';
            CloseFile(ArquivoDoObjeto);
         end
         else begin
            SetLength(LPontosAux,NPontosAux);
            Centro:=Ponto.create(0,0,0);
            for i:=0 to NPontosAux-1 do begin
               read(ArquivoDoObjeto,x,y,z);
               z:=z*FatorDilatacaoZ;
               if (IOResult<>0)or(eof(ArquivoDoObjeto)) then break;
               Centro.xm:=Centro.xm + x;
               Centro.ym:=Centro.ym + y;
               Centro.zm:=Centro.zm + z;
               LPontosAux[i]:=Ponto.create(x,y,z);
            end;
            if (IOResult<>0) or(eof(ArquivoDoObjeto))then  begin
               result:='Arquivo com inconsistncias nos pontos.';
               for j:=0 to i-1 do LPontosAux[j].Free;
               Centro.Free;
               LPontosAux:=nil;
            end
            else begin
               LTriangulosAux:=TList.create;
               for i:=0 to NTriangulosAux-1 do begin
                  read(ArquivoDoObjeto,A,B,C);
                  if (IOResult<>0)or(eof(ArquivoDoObjeto))or
                  (A<1)or(A>NPontosAux)or(B<1)or(B>NPontosAux)or
                  (C<1)or(C>NPontosAux) then break;
                  Tri:=Triangulo.create(A,B,C);
                  if ((i+1)mod 4=0) then Tri.tet:=(i+1) div 4
                  else Tri.tet:=((i+1) div 4)+1;
                  LTriangulosAux.Add(Tri);
               end;
               if (IOResult<>0)or(eof(ArquivoDoObjeto))or
                     (A<1)or(A>NPontosAux)or(B<1)or(B>NPontosAux)or
                     (C<1)or(C>NPontosAux) then begin
                  result:='Arquivo com inconsistncias nos tringulos.';
                  for j:=0 to i-1 do begin
                     Tri:=LTriangulosAux[j];
                     Tri.Free;
                  end;
                  LTriangulosAux.Free;
                  for j:=0 to NPontosAux-1 do LPontosAux[j].Free;
                  LPontosAux:=nil;
                  Centro.Free;
               end
               else begin
                  prepara_listas;
                  NPontos:=NPontosAux;
                  NTriangulos:=NTriangulosAux;
                  LPontos:=LPontosAux;
                  LTriangulos:=LTriangulosAux;
                  Centro.xm:=Centro.xm/NPontos;
                  Centro.ym:=Centro.ym/NPontos;
                  Centro.zm:=Centro.zm/NPontos;
                  result:='                                             ';
               end;
            end;
         end;
      end;
   end;
   {$I+}
end;


function prepara_objeto(strOdir,strOdig,strOdib,strOder,strOdeg,strOdeb,
                        strOsir,strOsig,strOsib,strOser,strOseg,strOseb,strkd,
                        strks,strn:string):string;
var
    Odir,Odig,Odib,Osir,Osig,Osib,Oder,Odeg,Odeb,Oser,Oseg,Oseb:real;
    erro:Boolean;
begin
   DecimalSeparator:='.';
   result:='                                                    ';
   Odir:=obter_real(strOdir,erro);
   if (not erro) and (Odir>=0) and (Odir<256) then begin
       Odig:=obter_real(strOdig,erro);
       if (not erro) and (Odig>=0) and (Odig<256)  then begin
          Odib:=obter_real(strOdib,erro);
          if (not erro) and (Odib>=0) and (Odib<256) then begin
             Osir:=obter_real(strOsir,erro);
             if (not erro) and (Osir>=0) and (Osir<256) then begin
                Osig:=obter_real(strOsig,erro);
                if (not erro) and (Osig>=0) and (Osig<256)then begin
                   Osib:=obter_real(strOsib,erro);
                   if (not erro) and (Osib>=0) and (Osib<256) then begin
                      kd:=obter_real(strkd,erro);
                      if (not erro) and (kd>=0) and (kd<=1.0) then begin
                         ks:=obter_real(strks,erro);
                         if (not erro) and (ks>=0) and (ks<=1.0) then begin
                            rugosidade:=obter_real(strn,erro);
                            if (not erro) and (rugosidade>0)  then begin
                               Oder:=obter_real(strOder,erro);
                               if (not erro) and (Oder>=0) and (Oder<256) then begin
                                  Odeg:=obter_real(strOdeg,erro);
                                  if (not erro) and (Odeg>=0) and (Odeg<256)  then begin
                                     Odeb:=obter_real(strOdeb,erro);
                                     if (not erro) and (Odeb>=0) and (Odeb<256) then begin
                                        Oser:=obter_real(strOser,erro);
                                        if (not erro) and (Oser>=0) and (Oser<256) then begin
                                           Oseg:=obter_real(strOseg,erro);
                                           if (not erro) and (Oseg>=0) and (Oseg<256)then begin
                                              Oseb:=obter_real(strOseb,erro);
                                              if (not erro) and (Oseb>=0) and (Oseb<256) then  //begin
//                                                 FatorDilatacaoZ:=obter_real(strFDZ,erro);
//                                                 if (not erro) and (FatorDilatacaoZ>0) then
                                                    result:='                                       '
//                                                 else
//                                                    result:='Fator de Dilatao de Z em formato invlido.';
                                              //end
                                              else
                                                 result:='Os L2(blue) em formato invlido.';
                                           end
                                           else
                                              result:='Os L2(green) em formato invlido.';
                                        end
                                        else
                                           result:='Os L2(red) em formato invlido.';
                                     end
                                     else
                                        result:='Od L2(blue) em formato invlido.';
                                  end
                                  else
                                     result:='Od L2(green) em formato invlido.';
                               end
                               else
                                  result:='Od L2(red) em formato invlido.';
                           end
                           else
                               result:='Rugosidade em formato invlido.';
                         end
                         else
                            result:='ks em formato invlido.';
                      end
                      else
                         result:='kd em formato invlido.';
                   end
                   else
                      result:='Os L1(blue) em formato invlido.';
                end
                else
                   result:='Os L1(green) em formato invlido.';
             end
             else
                result:='Os L1(red) em formato invlido.';
          end
          else
             result:='Od L1(blue) em formato invlido.';
       end
       else
          result:='Od L1(green) em formato invlido.';
   end
   else
      result:='Od L1(red) em formato invlido.';
   if (not erro)and(result[1]=' ') then begin
      Odi:=Cor.create(Odir,Odig,Odib);
      Osi:=Cor.create(Osir,Osig,Osib);
      Ode:=Cor.create(Oder,Odeg,Odeb);
      Ose:=Cor.create(Oser,Oseg,Oseb);
   end;
end;

end.
