unit uWireframe;

interface
uses Classes,Windows,Graphics,ExtCtrls,Forms,SysUtils,Math,uInstrumental_Basico,
uBitMap,uCamera,uTriangulo,uObjeto,uCena,uCorte;

function wireframe_com_linhas_escondidas:TBitmap;
function wireframe:TBitmap;
function wireframe_tetra:TBitmap;


implementation


procedure desenha_triangulo(A,B,C:integer);
var  k,xs0,ys0,xs1,ys1:integer;
     xv0,yv0,zv0,xv1,yv1,zv1,xv2,yv2,zv2,xc0,yc0,xc1,yc1:real;
     res:byte;
     intersecta:Boolean;
begin
   intersecta:=False;
   k:=A-1;
   xv0:=LPontos[k].x;
   yv0:=LPontos[k].y;
   zv0:=LPontos[k].z;
   k:=B-1;
   xv1:=LPontos[k].x;
   yv1:=LPontos[k].y;
   zv1:=LPontos[k].z;

   res:=corte_aresta_3D(xv0,yv0,zv0,xv1,yv1,zv1);  //AB
   if res>0 then begin
      if res=2 then begin
         intersecta:=True;
         xc0:=xv0;  yc0:=yv0;
      end
      else if  res=3  then begin
         intersecta:=True;
         xc0:=xv1;  yc0:=yv1;
      end;
      xv0:=Camera1.d*xv0/(Camera1.hx*zv0);
      yv0:=Camera1.d*yv0/(Camera1.hy*zv0);
      xv1:=Camera1.d*xv1/(Camera1.hx*zv1);
      yv1:=Camera1.d*yv1/(Camera1.hy*zv1);
      if corte_de_aresta(xv0,yv0,xv1,yv1) then begin
         xs0:=round((xv0+1)*meia_largura);
         ys0:=Altura-round((yv0+1)*meia_altura);
         Bitmap.Canvas.MoveTo(xs0,ys0);
         xs1:=round((xv1+1)*meia_largura);
         ys1:=Altura-round((yv1+1)*meia_altura);
         Bitmap.Canvas.LineTo(xs1,ys1);
     end;
   end;

   k:=A-1;
   xv0:=LPontos[k].x;
   yv0:=LPontos[k].y;
   zv0:=LPontos[k].z;
   k:=C-1;
   xv2:=LPontos[k].x;
   yv2:=LPontos[k].y;
   zv2:=LPontos[k].z;

   res:=corte_aresta_3D(xv0,yv0,zv0,xv2,yv2,zv2);  //AC
   if res>0 then begin
      if res=2 then begin
         if intersecta then begin
            xc1:=xv0;  yc1:=yv0;
         end
         else begin
            intersecta:=True;
            xc0:=xv0;  yc0:=yv0;
         end;
      end
      else if  res=3  then  begin
         if intersecta then begin
            xc1:=xv2;  yc1:=yv2;
         end
         else begin
            intersecta:=True;
            xc0:=xv2;  yc0:=yv2;
         end;
      end;
      xv0:=Camera1.d*xv0/(Camera1.hx*zv0);
      yv0:=Camera1.d*yv0/(Camera1.hy*zv0);
      xv2:=Camera1.d*xv2/(Camera1.hx*zv2);
      yv2:=Camera1.d*yv2/(Camera1.hy*zv2);
      if corte_de_aresta(xv0,yv0,xv2,yv2) then begin
         xs0:=round((xv0+1)*meia_largura);
         ys0:=Altura-round((yv0+1)*meia_altura);
         Bitmap.Canvas.MoveTo(xs0,ys0);
         xs1:=round((xv2+1)*meia_largura);
         ys1:=Altura-round((yv2+1)*meia_altura);
         Bitmap.Canvas.LineTo(xs1,ys1);
     end;
   end;

   k:=B-1;
   xv1:=LPontos[k].x;
   yv1:=LPontos[k].y;
   zv1:=LPontos[k].z;
   k:=C-1;
   xv2:=LPontos[k].x;
   yv2:=LPontos[k].y;
   zv2:=LPontos[k].z;

   res:=corte_aresta_3D(xv1,yv1,zv1,xv2,yv2,zv2);  //BC
   if res>0 then begin
      if res=2 then begin
         xc1:=xv1;  yc1:=yv1;
      end
      else if  res=3 then  begin
         xc1:=xv2;  yc1:=yv2;
      end;
      xv1:=Camera1.d*xv1/(Camera1.hx*zv1);
      yv1:=Camera1.d*yv1/(Camera1.hy*zv1);
      xv2:=Camera1.d*xv2/(Camera1.hx*zv2);
      yv2:=Camera1.d*yv2/(Camera1.hy*zv2);
      if corte_de_aresta(xv1,yv1,xv2,yv2) then begin
         xs0:=round((xv1+1)*meia_largura);
         ys0:=Altura-round((yv1+1)*meia_altura);
         Bitmap.Canvas.MoveTo(xs0,ys0);
         xs1:=round((xv2+1)*meia_largura);
         ys1:=Altura-round((yv2+1)*meia_altura);
         Bitmap.Canvas.LineTo(xs1,ys1);
     end;
   end;
   if intersecta then begin
      xv1:=xc0/Camera1.hx;
      yv1:=yc0/Camera1.hy;
      xv2:=xc1/Camera1.hx;
      yv2:=yc1/Camera1.hy;
      if corte_de_aresta(xv1,yv1,xv2,yv2) then begin
         xs0:=round((xv1+1)*meia_largura);
         ys0:=Altura-round((yv1+1)*meia_altura);
         Bitmap.Canvas.MoveTo(xs0,ys0);
         xs1:=round((xv2+1)*meia_largura);
         ys1:=Altura-round((yv2+1)*meia_altura);
         Bitmap.Canvas.LineTo(xs1,ys1);
     end;
   end;

end;



procedure pinta_quadrilatero(red,green,blue:Byte; xv0,yv0,zv0,xv1,yv1,
                          zv1,xv2,yv2,zv2,xv3,yv3,zv3:real);
var    Quadr:array of TPoint;
begin
   SetLength(Quadr,4);
   Bitmap.Canvas.Brush.Color:=RGB(red,green,blue);
   xv0:=Camera1.d*xv0/(Camera1.hx*zv0);
   yv0:=Camera1.d*yv0/(Camera1.hy*zv0);
   xv1:=Camera1.d*xv1/(Camera1.hx*zv1);
   yv1:=Camera1.d*yv1/(Camera1.hy*zv1);
   xv2:=Camera1.d*xv2/(Camera1.hx*zv2);
   yv2:=Camera1.d*yv2/(Camera1.hy*zv2);
   xv3:=Camera1.d*xv3/(Camera1.hx*zv3);
   yv3:=Camera1.d*yv3/(Camera1.hy*zv3);

   Quadr[0].x:=round((xv0+1)*meia_largura);
   Quadr[0].y:=Altura-round((yv0+1)*meia_altura);
   Quadr[1].x:=round((xv1+1)*meia_largura);
   Quadr[1].y:=Altura-round((yv1+1)*meia_altura);
   Quadr[2].x:=round((xv2+1)*meia_largura);
   Quadr[2].y:=Altura-round((yv2+1)*meia_altura);
   Quadr[3].x:=round((xv3+1)*meia_largura);
   Quadr[3].y:=Altura-round((yv3+1)*meia_altura);
   Bitmap.Canvas.Polygon(Quadr);
   SetLength(Quadr,0);
end;


procedure pinta_triangulo(red,green,blue:Byte; xv0,yv0,zv0,xv1,yv1,
                          zv1,xv2,yv2,zv2:real);
var    Triang:array of TPoint;
begin
   SetLength(Triang,3);
   Bitmap.Canvas.Brush.Color:=RGB(red,green,blue);
   xv0:=Camera1.d*xv0/(Camera1.hx*zv0);
   yv0:=Camera1.d*yv0/(Camera1.hy*zv0);
   xv1:=Camera1.d*xv1/(Camera1.hx*zv1);
   yv1:=Camera1.d*yv1/(Camera1.hy*zv1);
   xv2:=Camera1.d*xv2/(Camera1.hx*zv2);
   yv2:=Camera1.d*yv2/(Camera1.hy*zv2);

   Triang[0].x:=round((xv0+1)*meia_largura);
   Triang[0].y:=Altura-round((yv0+1)*meia_altura);
   Triang[1].x:=round((xv1+1)*meia_largura);
   Triang[1].y:=Altura-round((yv1+1)*meia_altura);
   Triang[2].x:=round((xv2+1)*meia_largura);
   Triang[2].y:=Altura-round((yv2+1)*meia_altura);
   Bitmap.Canvas.Polygon(Triang);
   SetLength(Triang,0);
end;

procedure desenha_tetraedro(xxv0,yyv0,zzv0,xxv1,yyv1,zzv1,xxv2,yyv2,zzv2,xxv3,yyv3,zzv3:real);
var  k,xs0,ys0,xs1,ys1:integer;
     xv0,yv0,zv0,xv1,yv1,zv1,xv2,yv2,zv2,xv3,yv3,zv3,xc0,yc0,xc1,yc1:real;
     res:byte;
     intersecta:Boolean;
begin
   intersecta:=False;
   xv0:=xxv0;
   yv0:=yyv0;
   zv0:=zzv0;
   xv1:=xxv1;
   yv1:=yyv1;
   zv1:=zzv1;

   xv0:=Camera1.d*xv0/(Camera1.hx*zv0);
   yv0:=Camera1.d*yv0/(Camera1.hy*zv0);
   xv1:=Camera1.d*xv1/(Camera1.hx*zv1);
   yv1:=Camera1.d*yv1/(Camera1.hy*zv1);
   xs0:=round((xv0+1)*meia_largura);
   ys0:=Altura-round((yv0+1)*meia_altura);
   Bitmap.Canvas.MoveTo(xs0,ys0);
   xs1:=round((xv1+1)*meia_largura);
   ys1:=Altura-round((yv1+1)*meia_altura);
   Bitmap.Canvas.LineTo(xs1,ys1);


   xv0:=xxv0;
   yv0:=yyv0;
   zv0:=zzv0;
   xv2:=xxv2;
   yv2:=yyv2;
   zv2:=zzv2;

   xv0:=Camera1.d*xv0/(Camera1.hx*zv0);
   yv0:=Camera1.d*yv0/(Camera1.hy*zv0);
   xv2:=Camera1.d*xv2/(Camera1.hx*zv2);
   yv2:=Camera1.d*yv2/(Camera1.hy*zv2);
   xs0:=round((xv0+1)*meia_largura);
   ys0:=Altura-round((yv0+1)*meia_altura);
   Bitmap.Canvas.MoveTo(xs0,ys0);
   xs1:=round((xv2+1)*meia_largura);
   ys1:=Altura-round((yv2+1)*meia_altura);
   Bitmap.Canvas.LineTo(xs1,ys1);

   xv1:=xxv1;
   yv1:=yyv1;
   zv1:=zzv1;
   xv2:=xxv2;
   yv2:=yyv2;
   zv2:=zzv2;

   xv1:=Camera1.d*xv1/(Camera1.hx*zv1);
   yv1:=Camera1.d*yv1/(Camera1.hy*zv1);
   xv2:=Camera1.d*xv2/(Camera1.hx*zv2);
   yv2:=Camera1.d*yv2/(Camera1.hy*zv2);
   xs0:=round((xv1+1)*meia_largura);
   ys0:=Altura-round((yv1+1)*meia_altura);
   Bitmap.Canvas.MoveTo(xs0,ys0);
   xs1:=round((xv2+1)*meia_largura);
   ys1:=Altura-round((yv2+1)*meia_altura);
   Bitmap.Canvas.LineTo(xs1,ys1);

   xv0:=xxv0;
   yv0:=yyv0;
   zv0:=zzv0;
   xv3:=xxv3;
   yv3:=yyv3;
   zv3:=zzv3;

   xv0:=Camera1.d*xv0/(Camera1.hx*zv0);
   yv0:=Camera1.d*yv0/(Camera1.hy*zv0);
   xv3:=Camera1.d*xv3/(Camera1.hx*zv3);
   yv3:=Camera1.d*yv3/(Camera1.hy*zv3);
   xs0:=round((xv0+1)*meia_largura);
   ys0:=Altura-round((yv0+1)*meia_altura);
   Bitmap.Canvas.MoveTo(xs0,ys0);
   xs1:=round((xv3+1)*meia_largura);
   ys1:=Altura-round((yv3+1)*meia_altura);
   Bitmap.Canvas.LineTo(xs1,ys1);

   xv1:=xxv1;
   yv1:=yyv1;
   zv1:=zzv1;
   xv3:=xxv3;
   yv3:=yyv3;
   zv3:=zzv3;

   xv1:=Camera1.d*xv1/(Camera1.hx*zv1);
   yv1:=Camera1.d*yv1/(Camera1.hy*zv1);
   xv3:=Camera1.d*xv3/(Camera1.hx*zv3);
   yv3:=Camera1.d*yv3/(Camera1.hy*zv3);
   xs0:=round((xv1+1)*meia_largura);
   ys0:=Altura-round((yv1+1)*meia_altura);
   Bitmap.Canvas.MoveTo(xs0,ys0);
   xs1:=round((xv3+1)*meia_largura);
   ys1:=Altura-round((yv3+1)*meia_altura);
   Bitmap.Canvas.LineTo(xs1,ys1);

   xv2:=xxv2;
   yv2:=yyv2;
   zv2:=zzv2;
   xv3:=xxv3;
   yv3:=yyv3;
   zv3:=zzv3;

   xv2:=Camera1.d*xv2/(Camera1.hx*zv2);
   yv2:=Camera1.d*yv2/(Camera1.hy*zv2);
   xv3:=Camera1.d*xv3/(Camera1.hx*zv3);
   yv3:=Camera1.d*yv3/(Camera1.hy*zv3);
   xs0:=round((xv2+1)*meia_largura);
   ys0:=Altura-round((yv2+1)*meia_altura);
   Bitmap.Canvas.MoveTo(xs0,ys0);
   xs1:=round((xv3+1)*meia_largura);
   ys1:=Altura-round((yv3+1)*meia_altura);
   Bitmap.Canvas.LineTo(xs1,ys1);
end;


function wireframe_tetra:TBitmap;
var  i,j,k,xs0,ys0,xs1,ys1:integer;
     xv0,yv0,zv0,xv1,yv1,zv1:real;
     meia_altura,x,y:real;
     T:Triangulo;
begin
   Bitmap.Canvas.Brush.Color:=RGB(0,0,0);
   Bitmap.Canvas.Rectangle(1,1,Largura,Altura);
   Bitmap.Canvas.Pen.Color:=RGB(255,255,0);
   desenha_tetraedro(LPontos[0].x,LPontos[0].y,LPontos[0].z,LPontos[1].x,LPontos[1].y,LPontos[1].z,
   LPontos[2].x,LPontos[2].y,LPontos[2].z,LPontos[3].x,LPontos[3].y,LPontos[3].z);

   result:=Bitmap;
end;



function wireframe:TBitmap;
var  i,j,k,xs0,ys0,xs1,ys1:integer;
     xv0,yv0,zv0,xv1,yv1,zv1:real;
     meia_altura,x,y:real;
     T:Triangulo;
begin
   Bitmap.Canvas.Brush.Color:=RGB(0,0,0);
   Bitmap.Canvas.Rectangle(1,1,Largura,Altura);
   Bitmap.Canvas.Pen.Color:=RGB(255,255,0);
   for i:=0 to LTriangulos.Count-1 do begin
      T:=LTriangulos[i];
      desenha_triangulo(T.A,T.B,T.C);
   end;
   result:=Bitmap;
end;

function wireframe_com_linhas_escondidas:TBitmap;
var i,k,A,B,C:integer;
    T:Triangulo;
    corte:short;
    Kab,Kac,Kbc,xc0,yc0,xc1,yc1:real;
begin
   Bitmap.Canvas.Pen.Color:=RGB(255,255,0);
   Bitmap.Canvas.Brush.Color:=RGB(0,0,0);
   Bitmap.Canvas.Rectangle(1,1,Largura,Altura);
   obter_distancias;
   LTriangulos.Sort(compare);
   for i:=LTriangulos.Count-1 downto 0 do begin
      T:=LTriangulos[i];
      A:=T.A - 1;
      B:=T.B - 1;
      C:=T.C - 1;
      corte:=corte_triangulo_3D(T,Kab,Kac,Kbc);
      if corte>=0 then begin
         case corte of
            0:pinta_triangulo(0,0,0,LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z);
            1:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc1:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 pinta_quadrilatero(0,0,0,xc0,yc0,Camera1.d,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                    xc1,yc1,Camera1.d);
              end;
            2:begin
                 xc0:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 pinta_triangulo(0,0,0,xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z);
               end;
            3:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 pinta_triangulo(0,0,0,xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z);
               end;
            4:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 pinta_quadrilatero(0,0,0,xc0,yc0,Camera1.d,
                                    LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                    xc1,yc1,Camera1.d);
              end;
            5:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc1:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 pinta_triangulo(0,0,0,xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                    LPontos[A].x,LPontos[A].y,LPontos[A].z);
               end;
            6:begin
                 xc0:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 pinta_quadrilatero(0,0,0,xc0,yc0,Camera1.d,
                                    LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                    xc1,yc1,Camera1.d);
              end;
         end;
      end;
   end;
   result:=Bitmap;
end;
end.
