unit uCamera;

interface
uses Classes,Windows,Graphics,ExtCtrls,Forms,SysUtils,Math,uInstrumental_Basico;

Type

Camera = Class
  Public
  N,U,V:vetor;
  C:Ponto;
  d,hx,hy:real;
  constructor create(Nx,Ny,Nz,Vx,Vy,Vz,Cx,Cy,Cz,d,hx,hy:real);
  procedure carrega(N1,V1:vetor;C1:Ponto;d1,hx1,hy1:real);
end;

function prepara_camera(strNx,strNy,strNz,strVx,strVy,strVz,strCx,
                        strCy,strCz,strd,strhx,strhy:string):string;

Var
    Camera1:Camera;
const Peq=0.000001;

implementation

procedure Camera.carrega(N1,V1:vetor;C1:Ponto;d1,hx1,hy1:real);
var Vtmp:vetor;
    k:real;
begin
    N.copia(N1); V.copia(V1);
    Vtmp:=vetor.create(0,1,0);
    if N.eh_nulo then begin
      N.carrega(0,0,1);
      V.carrega(0,1,0);
    end
    else  N.normalizado;
    if V.eh_nulo or N.eh_multiplo_de(V) then begin
      if abs(N.x)<Peq then V.x:=1
      else V.x:=0;
    end;
    k:=V.escalar(N1);
    Vtmp.copia(N1);
    Vtmp.vezes(k);
    V.menos(Vtmp);
    V.normalizado;
    U.copia(N);
    U.vezesRMD(V);
    U.normalizado;
    d:=d1; hx:=hx1; hy:=hy1;
    C.copia(C1);
    Vtmp.Free;
end;

constructor Camera.create(Nx,Ny,Nz,Vx,Vy,Vz,Cx,Cy,Cz,d,hx,hy:real);
begin
   inherited create;
   N:=vetor.create(Nx,Ny,Nz);
   V:=vetor.create(Vx,Vy,Vz);
   U:=vetor.create(0,0,0);
   C:=Ponto.create(Cx,Cy,Cz);
   carrega(N,V,C,d,hx,hy);
end;

function prepara_camera(strNx,strNy,strNz,strVx,strVy,strVz,strCx,
                        strCy,strCz,strd,strhx,strhy:string):string;
var Nx,Ny,Nz,Vx,Vy,Vz,Cx,Cy,Cz,d,hx,hy:real;
    erro:Boolean;
begin
   result:='                                                    ';
   Nx:=obter_real(strNx,erro);
   if not erro then begin
       Ny:=obter_real(strNy,erro);
       if not erro then begin
          Nz:=obter_real(strNz,erro);
          if not erro then begin
             Vx:=obter_real(strVx,erro);
             if not erro then begin
                Vy:=obter_real(strVy,erro);
                if not erro then begin
                   Vz:=obter_real(strVz,erro);
                   if not erro then begin
                      Cx:=obter_real(strCx,erro);
                      if not erro then begin
                         Cy:=obter_real(strCy,erro);
                         if not erro then begin
                            Cz:=obter_real(strCz,erro);
                            if not erro then begin
                               d:=obter_real(strd,erro);
                               if (not erro) and (d>0) then begin
                                  hx:=obter_real(strhx,erro);
                                  if (not erro) and (hx>0) then begin
                                     hy:=obter_real(strhy,erro);
                                     if (not erro) and (hy>=0) then begin
                                        result:='                                       ';
                                     end
                                     else begin
                                        result:='hy em formato invlido.';
                                        erro:=True;
                                     end;
                                  end
                                  else begin
                                     result:='hx em formato invlido.';
                                     erro:=True;
                                  end;
                               end
                               else begin
                                  result:='d(dist. focal) em formato invlido.';
                                  erro:=True;
                               end;
                            end
                            else
                               result:='C.z em formato invlido.';
                         end
                         else
                            result:='C.y em formato invlido.';
                      end
                      else
                         result:='C.x em formato invlido.';
                   end
                   else
                      result:='V.z em formato invlido.';
                end
                else
                   result:='V.y em formato invlido.';
             end
             else
                result:='V.x em formato invlido.';
          end
          else
             result:='N.z em formato invlido.';
       end
       else
          result:='N.y em formato invlido.';
   end
   else
      result:='N.x em formato invlido.';
   if not erro then
      if Camera1=nil then
         Camera1:=Camera.create(Nx,Ny,Nz,Vx,Vy,Vz,Cx,Cy,Cz,d,hx,hy)
      else begin
         Camera1.N.carrega(Nx,Ny,Nz);
         Camera1.V.carrega(Vx,Vy,Vz);
         Camera1.C.carrega_mundial(Cx,Cy,Cz);
         Camera1.carrega(Camera1.N,Camera1.V,Camera1.C,d,hx,hy);
      end;
end;


end.
