unit uCena;

interface
uses Classes,Windows,Graphics,ExtCtrls,Forms,SysUtils,Math,uInstrumental_Basico,
uCamera;


Var
    LFontesCont:integer;
    LCoresDasFontes:array of Cor;
    LPosicoesDasFontes:array of Ponto;

    ka:real;
    Ia:Cor;
function prepara_cena(strIar,strIag,strIab,strKa:string):string;
function prepara_listas_das_fontes_de_luz(LFontes:TStringList):string;

implementation


function prepara_listas_das_fontes_de_luz(LFontes:TStringList):string;
var i,j,nFontes,base:integer;
    Ilr,Ilg,Ilb,Plx,Ply,Plz:real;
    erro:Boolean;
    str:string;
begin
   result:='                                            ';
   if LCoresDasFontes<>nil then begin
      for i:=0 to LFontesCont-1 do begin
         LCoresDasFontes[i].Free;
         LPosicoesDasFontes[i].Free;
      end;
      SetLength(LCoresDasFontes,0);
      SetLength(LPosicoesDasFontes,0);
   end;
   nFontes:=LFontes.Count div 6;
   SetLength(LCoresDasFontes,nFontes);
   SetLength(LPosicoesDasFontes,nFontes);
   base:=0;
   for j:=0 to nFontes-1 do begin
      Ilr:=obter_real(LFontes[base],erro);
      if (not erro) and (Ilr<=255) and (Ilr>=0) then begin
         Ilg:=obter_real(LFontes[base+1],erro);
         if (not erro) and (Ilg<=255) and (Ilg>=0) then begin
            Ilb:=obter_real(LFontes[base+2],erro);
            if (not erro) and (Ilb<=255) and (Ilb>=0) then begin
               Plx:=obter_real(LFontes[base+3],erro);
               if (not erro) then begin
                  str:=LFontes[base+4];
                  Ply:=obter_real(str,erro);
                  if (not erro) then begin
                     Plz:=obter_real(LFontes[base+5],erro);
                     if erro then
                        result:='Posio da Fonte '+IntToStr(j+1)+' com erro (Coord z).';
                  end
                  else
                     result:='Posio da Fonte '+IntToStr(j+1)+' com erro (Coord y).';
               end
               else
                  result:='Posio da Fonte '+IntToStr(j+1)+' com erro (Coord x).';
            end
            else begin
               result:='Cor da Fonte '+IntToStr(j+1)+' com erro (blue).';
               erro:=True;
            end;
         end
         else begin
            result:='Cor da Fonte '+IntToStr(j+1)+' com erro (green).';
            erro:=True;
         end;
      end
      else begin
         result:='Cor da Fonte '+IntToStr(j+1)+' com erro (red).';
         erro:=True;
      end;

      if erro then break
      else begin
         LCoresDasFontes[j]:=Cor.create(Ilr,Ilg,Ilb);
         LPosicoesDasFontes[j]:=Ponto.create(Plx,Ply,Plz);
      end;
      base:=base+6;
   end;
   if erro then begin
      for i:=0 to j-1 do begin
         LCoresDasFontes[i].Free;
         LPosicoesDasFontes[i].Free;
      end;
      LFontesCont:=0;
      SetLength(LCoresDasFontes,0);
      SetLength(LPosicoesDasFontes,0);
   end
   else LFontesCont:=nFontes;
end;


function prepara_cena(strIar,strIag,strIab,strKa:string):string;
var Iar,Iag,Iab:real;
    erro:Boolean;
begin
   DecimalSeparator:='.';
   result:='                                                    ';
   Iar:=obter_real(strIar,erro);
   if (not erro) and (Iar>=0) and (Iar<256) then begin
       Iag:=obter_real(strIag,erro);
       if (not erro) and (Iag>=0) and (Iag<256)  then begin
          Iab:=obter_real(strIab,erro);
          if (not erro) and (Iab>=0) and (Iab<256) then begin
             Ka:=obter_real(strKa,erro);
             if (not erro) and (Ka>=0) and (Ka<=1.0) then
                result:='                                       '
             else
                result:='Ka em formato invlido.';
          end
          else
             result:='Ia(blue) em formato invlido.';
       end
       else
          result:='Ia(green) em formato invlido.';
   end
   else
      result:='Ia(red) em formato invlido.';
   if (not erro)and(result[1]=' ') then
      Ia:=Cor.create(Iar,Iag,Iab);
end;


end.
