unit uFlat_shading;

interface
uses Classes,Windows,Graphics,ExtCtrls,Forms,SysUtils,Math,uInstrumental_Basico,
uBitMap,uCamera,uTriangulo,uObjeto,uCena,uCorte;

function flat_shading:TBitmap;

var Tet_carregado:Boolean;
    Tet_modo:Boolean;
    Tet_cor:array[1..81] of Cor;
    Tet_habil:array[1..81] of Boolean;

implementation

procedure ilumina_triangulo_flat(N:vetor; xv0,yv0,zv0,xv1,yv1,
                          zv1,xv2,yv2,zv2:real);
var Li:integer;
    I,Id,Isp,Odif,Ospc,C:Cor;
    L,V,R:vetor;
    N_escalar_L,V_escalar_R:real;
    Triang:array of TPoint;
    Bari:Ponto;
begin
   I:=Cor.create(0,0,0);
   C:=Cor.create(0,0,0);
   Id:=Cor.create(0,0,0);
   Isp:=Cor.create(0,0,0);
   Ospc:=Cor.create(0,0,0);
   Odif:=Cor.create(0,0,0);
   L:=vetor.create(0,0,0);
   R:=vetor.create(0,0,0);
   V:=vetor.create(0,0,0);
   Bari:=Ponto.Create(0,0,0);
   Bari.carrega((xv0+xv1+xv2)/3,(yv0+yv1+yv2)/3,(zv0+zv1+zv2)/3);
   V.vetor_terminado_no_ponto(Bari);
   V.simetrico;
   V.normalizado;
   if V.escalar(N)<0 then begin
      Odif.copia(Odi);
      Ospc.copia(Osi);
      N.simetrico;
   end
   else begin
      Odif.copia(Ode);
      Ospc.copia(Ose);
   end;
   Odif.vezes(Kd);
   Ospc.vezes(Ks);
   Odif.normalizada;
   Ospc.normalizada;
   I.copia(Ia);
   I.vezes(Ka);
   for Li:=0 to LFontesCont-1 do begin
      L.carrega(LPosicoesDasFontes[Li],Bari);
      if N.escalar(L)>0 then begin
         L.normalizado;
         N_escalar_L:=N.escalar(L);
         produto(C,N_escalar_L,Odif,LCoresDasFontes[Li]);
         Id.mais(C);
         if Ks>0 then begin
            R.copia(N);
            R.vezes(2*N_escalar_L);
            R.menos(L);
            V_escalar_R:=V.escalar(R);
            if V_escalar_R>0 then begin
               V_escalar_R:=Math.Power(V_escalar_R,rugosidade);
               produto(C,V_escalar_R,Ospc,LCoresDasFontes[Li]);
               Isp.mais(C);
            end;
         end;
      end;
   end;
   I.mais(Id);
   I.mais(Isp);
   I.truncada;
   Bitmap.Canvas.Brush.Color:=RGB(round(I.r),round(I.g),round(I.b));
   Bitmap.Canvas.Pen.Color:=Bitmap.Canvas.Brush.Color;
   C.Free;
   I.Free;
   Id.Free;
   Isp.Free;
   Ospc.Free;
   Odif.Free;
   L.Free;
   R.Free;
   V.Free;
   Bari.Free;


   SetLength(Triang,3);
   xv0:=Camera1.d*xv0/(Camera1.hx*zv0);
   yv0:=Camera1.d*yv0/(Camera1.hy*zv0);
   xv1:=Camera1.d*xv1/(Camera1.hx*zv1);
   yv1:=Camera1.d*yv1/(Camera1.hy*zv1);
   xv2:=Camera1.d*xv2/(Camera1.hx*zv2);
   yv2:=Camera1.d*yv2/(Camera1.hy*zv2);

   Triang[0].x:=round((xv0+1)*meia_largura);
   Triang[0].y:=Altura-round((yv0+1)*meia_altura);
   Triang[1].x:=round((xv1+1)*meia_largura);
   Triang[1].y:=Altura-round((yv1+1)*meia_altura);
   Triang[2].x:=round((xv2+1)*meia_largura);
   Triang[2].y:=Altura-round((yv2+1)*meia_altura);
   Bitmap.Canvas.Polygon(Triang);
   SetLength(Triang,0);

end;


procedure ilumina_quadrilatero_flat(N:vetor; xv0,yv0,zv0,xv1,yv1,
                          zv1,xv2,yv2,zv2,xv3,yv3,zv3:real);
var Li:integer;
    I,Id,Isp,Odif,Ospc,C:Cor;
    L,V,R:vetor;
    N_escalar_L,V_escalar_R:real;
    Quadr:array of TPoint;
    Bari:Ponto;
begin
   I:=Cor.create(0,0,0);
   C:=Cor.create(0,0,0);
   Id:=Cor.create(0,0,0);
   Isp:=Cor.create(0,0,0);
   Ospc:=Cor.create(0,0,0);
   Odif:=Cor.create(0,0,0);
   L:=vetor.create(0,0,0);
   R:=vetor.create(0,0,0);
   V:=vetor.create(0,0,0);
   Bari:=Ponto.Create(0,0,0);
   Bari.carrega((xv0+xv1+xv2+xv3)/4,(yv0+yv1+yv2+yv3)/4,(zv0+zv1+zv2+zv3)/4);
   V.vetor_terminado_no_ponto(Bari);
   V.simetrico;
   V.normalizado;
   if V.escalar(N)<0 then begin
      Odif.copia(Odi);
      Ospc.copia(Osi);
      N.simetrico;
   end
   else begin
      Odif.copia(Ode);
      Ospc.copia(Ose);
   end;
   Odif.vezes(Kd);
   Ospc.vezes(Ks);
   Odif.normalizada;
   Ospc.normalizada;
   I.copia(Ia);
   I.vezes(Ka);
   for Li:=0 to LFontesCont-1 do begin
      L.carrega(LPosicoesDasFontes[Li],Bari);
      if N.escalar(L)>0 then begin
         L.normalizado;
         N_escalar_L:=N.escalar(L);
         produto(C,N_escalar_L,Odif,LCoresDasFontes[Li]);
         Id.mais(C);
         if Ks>0 then begin
            R.copia(N);
            R.vezes(2*N_escalar_L);
            R.menos(L);
            V_escalar_R:=V.escalar(R);
            if V_escalar_R>0 then begin
               V_escalar_R:=Math.Power(V_escalar_R,rugosidade);
               produto(C,V_escalar_R,Ospc,LCoresDasFontes[Li]);
               Isp.mais(C);
            end;
         end;
      end;
   end;
   I.mais(Id);
   I.mais(Isp);
   I.truncada;
   Bitmap.Canvas.Brush.Color:=RGB(round(I.r),round(I.g),round(I.b));
   Bitmap.Canvas.Pen.Color:=Bitmap.Canvas.Brush.Color;
   C.Free;
   I.Free;
   Id.Free;
   Isp.Free;
   Ospc.Free;
   Odif.Free;
   L.Free;
   R.Free;
   V.Free;
   Bari.Free;


   SetLength(Quadr,4);
   xv0:=Camera1.d*xv0/(Camera1.hx*zv0);
   yv0:=Camera1.d*yv0/(Camera1.hy*zv0);
   xv1:=Camera1.d*xv1/(Camera1.hx*zv1);
   yv1:=Camera1.d*yv1/(Camera1.hy*zv1);
   xv2:=Camera1.d*xv2/(Camera1.hx*zv2);
   yv2:=Camera1.d*yv2/(Camera1.hy*zv2);
   xv3:=Camera1.d*xv3/(Camera1.hx*zv3);
   yv3:=Camera1.d*yv3/(Camera1.hy*zv3);

   Quadr[0].x:=round((xv0+1)*meia_largura);
   Quadr[0].y:=Altura-round((yv0+1)*meia_altura);
   Quadr[1].x:=round((xv1+1)*meia_largura);
   Quadr[1].y:=Altura-round((yv1+1)*meia_altura);
   Quadr[2].x:=round((xv2+1)*meia_largura);
   Quadr[2].y:=Altura-round((yv2+1)*meia_altura);
   Quadr[3].x:=round((xv3+1)*meia_largura);
   Quadr[3].y:=Altura-round((yv3+1)*meia_altura);
   Bitmap.Canvas.Polygon(Quadr);
   SetLength(Quadr,0);

end;

//-----------------------Algoritmos principais---------------------------------

function flat_shading:TBitmap;
var i,k,A,B,C:integer;
    T:Triangulo;
    corte:short;
    Vtmp:vetor;
    Kab,Kac,Kbc,xc0,yc0,xc1,yc1:real;
    Odef,Odif:Cor;

begin
   Bitmap.Canvas.Pen.Color:=RGB(255,255,0);
   Vtmp:=vetor.create(0,0,0);
   Bitmap.Canvas.Brush.Color:=RGB(0,0,0);
   Bitmap.Canvas.Rectangle(1,1,Largura,Altura);
   obter_distancias;
   LTriangulos.Sort(compare);
   if not Tet_modo then
      for i:=LTriangulos.Count-1 downto 0 do begin
         T:=LTriangulos[i];
         T.computa_normal(LPontos,Vtmp);
         A:=T.A - 1;
         B:=T.B - 1;
         C:=T.C - 1;
         corte:=corte_triangulo_3D(T,Kab,Kac,Kbc);
         if corte>=0 then begin
            case corte of
               0:ilumina_triangulo_flat(T.Normal,LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                       LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                       LPontos[C].x,LPontos[C].y,LPontos[C].z);
               1:begin
                    xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                    yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                    xc1:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                    yc1:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                    ilumina_quadrilatero_flat(T.Normal,xc0,yc0,Camera1.d,
                                       LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                       LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                       xc1,yc1,Camera1.d);
                 end;
               2:begin
                    xc0:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                    yc0:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                    xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                    yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                    ilumina_triangulo_flat(T.Normal,xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                       LPontos[C].x,LPontos[C].y,LPontos[C].z);
                  end;
               3:begin
                    xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                    yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                    xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                    yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                    ilumina_triangulo_flat(T.Normal,xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                       LPontos[B].x,LPontos[B].y,LPontos[B].z);
                 end;
               4:begin
                    xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                    yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                    xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                    yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                    ilumina_quadrilatero_flat(T.Normal,xc0,yc0,Camera1.d,
                                       LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                       LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                       xc1,yc1,Camera1.d);
                 end;
               5:begin
                    xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                    yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                    xc1:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                    yc1:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                    ilumina_triangulo_flat(T.Normal,xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                       LPontos[A].x,LPontos[A].y,LPontos[A].z);
                  end;
               6:begin
                    xc0:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                    yc0:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                    xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                    yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                    ilumina_quadrilatero_flat(T.Normal,xc0,yc0,Camera1.d,
                                       LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                       LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                       xc1,yc1,Camera1.d);
                 end;
            end;
         end;
      end
   else begin
      Odif:=Cor.create(0,0,0);
      Odef:=Cor.create(0,0,0);
      Odif.copia(Odi);
      Odef.copia(Ode);
      for i:=LTriangulos.Count-1 downto 0 do begin
         T:=LTriangulos[i];
         if not Tet_habil[T.tet] then continue;
         Ode.carrega(tet_cor[T.tet].r,tet_cor[T.tet].g,tet_cor[T.tet].b);
         Odi.copia(Ode);
         T.computa_normal(LPontos,Vtmp);
         A:=T.A - 1;
         B:=T.B - 1;
         C:=T.C - 1;
         corte:=corte_triangulo_3D(T,Kab,Kac,Kbc);
         if corte>=0 then begin
            case corte of
               0:ilumina_triangulo_flat(T.Normal,LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                       LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                       LPontos[C].x,LPontos[C].y,LPontos[C].z);
               1:begin
                    xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                    yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                    xc1:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                    yc1:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                    ilumina_quadrilatero_flat(T.Normal,xc0,yc0,Camera1.d,
                                       LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                       LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                       xc1,yc1,Camera1.d);
                 end;
               2:begin
                    xc0:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                    yc0:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                    xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                    yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                    ilumina_triangulo_flat(T.Normal,xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                       LPontos[C].x,LPontos[C].y,LPontos[C].z);
                  end;
               3:begin
                    xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                    yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                    xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                    yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                    ilumina_triangulo_flat(T.Normal,xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                       LPontos[B].x,LPontos[B].y,LPontos[B].z);
                 end;
               4:begin
                    xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                    yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                    xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                    yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                    ilumina_quadrilatero_flat(T.Normal,xc0,yc0,Camera1.d,
                                       LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                       LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                       xc1,yc1,Camera1.d);
                 end;
               5:begin
                    xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                    yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                    xc1:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                    yc1:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                    ilumina_triangulo_flat(T.Normal,xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                       LPontos[A].x,LPontos[A].y,LPontos[A].z);
                  end;
               6:begin
                    xc0:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                    yc0:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                    xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                    yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                    ilumina_quadrilatero_flat(T.Normal,xc0,yc0,Camera1.d,
                                       LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                       LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                       xc1,yc1,Camera1.d);
                 end;
            end;
         end;
      end;
      Odef.Free;
      Odif.Free;
   end;
   Vtmp.Free;
   result:=Bitmap;
end;

end.
