Unit uPhong;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,Math,
  Dialogs, StdCtrls, ExtCtrls,uInstrumental_Basico,uCamera,uTriangulo,uObjeto,
  uCena,uCorte,uBitMap,uCoordenadas,uZ_buffer;


function phong_shading:TBitmap;
function tphong_shading:TBitmap;

var tFacei,tFacef:integer;
    Od,Os:Cor;

implementation

const PEQUENO=0.9;


procedure equacao_iluminacao(var I:Cor; Caux,Id,Isp,Ospc,Odif:Cor;
                                 N,L,R,V:vetor;P:ponto);
var
    N_escalar_L,V_escalar_R:real;
    Li:integer;
begin
   Id.carrega(0,0,0);
   Isp.carrega(0,0,0);
   V.vetor_terminado_no_ponto(P);
   V.simetrico;
   V.normalizado;
   Odif.copia(Od);
   Ospc.copia(Os);
   Odif.vezes(Kd);
   Ospc.vezes(Ks);
   Odif.normalizada;
   Ospc.normalizada;
   I.copia(Ia);
   I.vezes(Ka);
   for Li:=0 to LFontesCont-1 do begin
      L.carrega(LPosicoesDasFontes[Li],P);
      if N.escalar(L)>0 then begin
         L.normalizado;
         N_escalar_L:=N.escalar(L);
         produto(Caux,N_escalar_L,Odif,LCoresDasFontes[Li]);
         Id.mais(Caux);
         if Ks>0 then begin
            R.copia(N);
            R.vezes(2*N_escalar_L);
            R.menos(L);
            V_escalar_R:=V.escalar(R);
            if V_escalar_R>0 then begin
               V_escalar_R:=Math.Power(V_escalar_R,rugosidade);
               produto(Caux,V_escalar_R,Ospc,LCoresDasFontes[Li]);
               Isp.mais(Caux);
            end;
         end;
      end;
   end;
   I.mais(Id);
   I.mais(Isp);
   I.truncada;
end;




function scanconvert( xv1,yv1,zv1,xv2,yv2,zv2,xv3,yv3,zv3:real;
                       N1,N2,N3,N:vetor):TBitMap;
var
   xmin,xmax,ymin,ymax,aux2,aux1,x1,y1,x2,y2,x3,y3:integer;
   delta12,delta23,delta13,deltaMin,deltaMax,t,t_numerador:real;
   Rxmin,Rxmax,px,py,alfa,beta,gama,z,xr,xb,dx:real;
   I,Id,Isp,Odif,Ospc,Caux:Cor;
   L,V,R,Np:vetor;
   P:Ponto;
   lado_oposto:Boolean;

procedure preambulo;
begin
   I:=Cor.create(0,0,0);
   Caux:=Cor.create(0,0,0);
   Id:=Cor.create(0,0,0);
   Isp:=Cor.create(0,0,0);
   Ospc:=Cor.create(0,0,0);
   Od:=Cor.create(0,0,0);
   Os:=Cor.create(0,0,0);
   Odif:=Cor.create(0,0,0);
   L:=vetor.create(0,0,0);
   R:=vetor.create(0,0,0);
   V:=vetor.create(0,0,0);
   Np:=vetor.create(0,0,0);
   P:=Ponto.create(0,0,0);
   x1:=round( (Camera1.d*xv1/(Camera1.hx*zv1) + 1)* meia_largura );
   y1:=round( (Camera1.d*yv1/(Camera1.hy*zv1) + 1)* meia_altura );
   x2:=round( (Camera1.d*xv2/(Camera1.hx*zv2) + 1)* meia_largura );
   y2:=round( (Camera1.d*yv2/(Camera1.hy*zv2) + 1)* meia_altura );
   x3:=round( (Camera1.d*xv3/(Camera1.hx*zv3) + 1)* meia_largura );
   y3:=round( (Camera1.d*yv3/(Camera1.hy*zv3) + 1)* meia_altura );
   if not((x1=x2)and(x1=x3)) and not((y1=y2)and(y1=y3)) and
      not((x1<0)and(x2<0)and(x3<0))and not((x1>Largura)and(x2>Largura)and(x3>Largura))
      and not((y1<0)and(y2<0)and(y3<0))and not ((y1>Altura)and(y2>Altura)and(y3>Altura)) then begin
      { PONTO MAIS ALTO E PONTO INTERMEDIARIO}
      t_numerador:=xv3*N.x + yv3*N.y + zv3*N.z;
      if y2>y1 then begin
         aux1 := x1;
         aux2 := y1;
         y1 := y2;
         x1 := x2;
         y2 := aux2;
         x2 := aux1;
      end;
      if y3>y1 then begin
         aux1 := x1;
         aux2 := y1;
         y1 := y3;
         x1 := x3;
         y3 := aux2;
         x3 := aux1;
      end;
      if y3>y2 then begin  {Ponto mais baixo}
         aux1 := x2;
         aux2 := y2;
         y2 := y3;
         x2 := x3;
         y3 := aux2;
         x3 := aux1;
      end;
      if y1=y2 then
         delta12:=0
      else
         delta12:= (x2-x1)/(y1-y2);
      if y2=y3 then
         delta23:=0
      else
         delta23:= (x3-x2)/(y2-y3);
      delta13:= (x3-x1)/(y1-y3);
   end;
end;
procedure finaliza;
begin
   Caux.Free;
   Id.Free;
   I.Free;
   Isp.Free;
   Ospc.Free;
   Od.Free;
   Os.Free;
   Odif.Free;
   L.Free;
   R.Free;
   V.Free;
   Np.Free;
   P.Free;
end;


procedure determina_lado_visivel;
begin
   P.carrega(xv1,yv1,zv1);
   V.vetor_terminado_no_ponto(P);
   V.simetrico;
   V.normalizado;
   if V.escalar(N)<0 then begin
      Od.copia(Odi);
      Os.copia(Osi);
      N.simetrico;
 {     N1.simetrico;
      N2.simetrico;
      N3.simetrico;}
   end
   else begin
      Od.copia(Ode);
      Os.copia(Ose);
   end;
   if V.escalar(N1)<0 then begin
      R.copia(V);
      R.vezes(R.escalar(N1));
      N1.menos(R);
   end;
   P.carrega(xv2,yv2,zv2);
   V.vetor_terminado_no_ponto(P);
   V.simetrico;
   V.normalizado;
   if V.escalar(N2)<0 then begin
      R.copia(V);
      R.vezes(R.escalar(N2));
      N2.menos(R);
   end;
   P.carrega(xv3,yv3,zv3);
   V.vetor_terminado_no_ponto(P);
   V.simetrico;
   V.normalizado;
   if V.escalar(N3)<0 then begin
      R.copia(V);
      R.vezes(R.escalar(N3));
      N3.menos(R);
   end;

end;

procedure varredura;
var yscan,x:integer;
begin
   xmin:=round(Rxmin);
   xmax:=round(Rxmax);
   if xmin<0 then xmin:=0;
   if xmax>Largura-1 then xmax:=Largura-1;
   if ymin<0 then ymin:=0;
   for yscan:=ymax downto ymin do begin
      py:=(yscan/meia_altura - 1)*Camera1.hy;
      xr:=Rxmin - xmin;
      xb:=Rxmax - xmax;
      if xmin=xmax then dx:=0
      else dx:=(xb - xr)/(xmax - xmin);
      for x:=xmin to xmax do begin
         px:=((x+xr+(x-xmin)*dx)/meia_largura - 1)*Camera1.hx;
         t:=t_numerador/(px*N.x + py*N.y + Camera1.d*N.z);
         coordenadas_baricentricas(xv1,yv1,xv2,yv2,xv3,yv3,t*px,t*py,alfa,beta,gama);
         if ((alfa>0)or(abs(alfa)<PEQUENO))and((beta>0)or(abs(beta)<PEQUENO))
            and ((gama>0)or(abs(gama)<PEQUENO)) then begin
            z:=alfa*zv1 + beta*zv2 + gama*zv3;
            if (z < z_buffer.pixel[x,yscan]) then begin
               z_buffer.pixel[x,yscan]:=z;
               P.x:=alfa*xv1 + beta*xv2 + gama*xv3;
               P.y:=alfa*yv1 + beta*yv2 + gama*yv3;
               P.z:=alfa*zv1 + beta*zv2 + gama*zv3;
               Np.x:=alfa*N1.x + beta*N2.x + gama*N3.x;
               Np.y:=alfa*N1.y + beta*N2.y + gama*N3.y;
               Np.z:=alfa*N1.z + beta*N2.z + gama*N3.z;
               equacao_iluminacao(I,Caux,Id,Isp,Ospc,Odif,Np,L,R,V,P);
               Bitmap.Canvas.Pixels[x,Altura-yscan] := RGB(trunc(I.r),trunc(I.g),trunc(I.b));
            end;
         end;
      end;
      Rxmin:=Rxmin+deltaMin;
      Rxmax:=Rxmax+deltaMax;
      xmin:= round(Rxmin);
      xmax:= round(Rxmax);
      if xmin<0 then xmin:=0;
      if xmax>Largura-1 then xmax:=Largura-1;
   end;
end;


begin
   preambulo;
   determina_lado_visivel;
   if y1=y2 then begin
      deltaMin:=delta13;
      deltaMax:=delta23;
      xmin:=x1;
      xmax:=x2;
      if delta13<delta23 then begin
         deltaMin:=delta23;
         deltaMax:=delta13;
         xmin:=x2;
         xmax:=x1;
      end;
      ymin:=y3;
      ymax:=y1;
      Rxmin := xmin;
      Rxmax := xmax;
      if ymax>Altura-1 then begin
         ymax:=Altura-1;
         Rxmin:=-deltaMin*(Altura-1-ymax)+xmin;
         Rxmax:=-deltaMax*(Altura-1-ymax)+xmax;
      end;
      varredura;
   end
   else begin
      deltaMin:=delta12;
      deltaMax:=delta13;
      if delta13<delta12 then begin
         deltaMin:=delta13;
         deltaMax:=delta12;
      end;
      Rxmin := x1;
      Rxmax := x1;
      ymin:=y2;
      ymax:=y1;
      if ymax>Altura-1 then begin
         ymax:=Altura-1;
         Rxmin:=-deltaMin*(Altura-1-y1)+x1;
         Rxmax:=-deltaMax*(Altura-1-y1)+x1;
      end;
      varredura;
      Rxmin:=Rxmin-deltaMin;
      Rxmax:=Rxmax-deltaMax;
      if y2<>y3 then begin
         deltaMin:=delta13;
         deltaMax:=delta23;
         if delta13<delta23 then begin
            deltaMin:=delta23;
            deltaMax:=delta13;
         end;
         ymin:=y3;
         ymax:=y2;
         if ymax>Altura-1 then begin
            ymax:=Altura-1;
            if delta13>delta23 then begin
               Rxmin:=-deltaMin*(Altura-1-y1)+x1;
               Rxmax:=-deltaMax*(Altura-1-y2)+x2;
            end
            else begin
               Rxmin:=-deltaMin*(Altura-1-y2)+x2;
               Rxmax:=-deltaMax*(Altura-1-y1)+x1;
            end;
         end;
         varredura;
      end;
   end;
   finaliza;
   scanconvert:=BitMap;
end;


function tscanconvert( xv1,yv1,zv1,xv2,yv2,zv2,xv3,yv3,zv3:real;
                       N1,N2,N3,N:vetor):TBitMap;
var
   xmin,xmax,ymin,ymax,aux2,aux1,x1,y1,x2,y2,x3,y3:integer;
   delta12,delta23,delta13,deltaMin,deltaMax,t,t_numerador:real;
   Rxmin,Rxmax,px,py,alfa,beta,gama,z,xr,xb,dx:real;
   I,Id,Isp,Odif,Ospc,Caux,tOde,tOdi:Cor;
   L,V,R,Np,Wt:vetor;
   P,Pproj:Ponto;

procedure preambulo;
begin
   I:=Cor.create(0,0,0);
   Caux:=Cor.create(0,0,0);
   Id:=Cor.create(0,0,0);
   Isp:=Cor.create(0,0,0);
   Ospc:=Cor.create(0,0,0);
   Odif:=Cor.create(0,0,0);
   tOdi:=Cor.create(0,0,0);
   tOde:=Cor.create(0,0,0);
   L:=vetor.create(0,0,0);
   R:=vetor.create(0,0,0);
   V:=vetor.create(0,0,0);
   Wt:=vetor.create(0,0,0);
   Np:=vetor.create(0,0,0);
   P:=Ponto.create(0,0,0);
   Pproj:=Ponto.create(0,0,0);
   tOde.copia(Ode);
   tOdi.copia(Odi);
   x1:=round( (Camera1.d*xv1/(Camera1.hx*zv1) + 1)* meia_largura );
   y1:=round( (Camera1.d*yv1/(Camera1.hy*zv1) + 1)* meia_altura );
   x2:=round( (Camera1.d*xv2/(Camera1.hx*zv2) + 1)* meia_largura );
   y2:=round( (Camera1.d*yv2/(Camera1.hy*zv2) + 1)* meia_altura );
   x3:=round( (Camera1.d*xv3/(Camera1.hx*zv3) + 1)* meia_largura );
   y3:=round( (Camera1.d*yv3/(Camera1.hy*zv3) + 1)* meia_altura );
   if not((x1=x2)and(x1=x3)) and not((y1=y2)and(y1=y3)) and
      not((x1<0)and(x2<0)and(x3<0))and not((x1>Largura)and(x2>Largura)and(x3>Largura))
      and not((y1<0)and(y2<0)and(y3<0))and not ((y1>Altura)and(y2>Altura)and(y3>Altura)) then begin
      { PONTO MAIS ALTO E PONTO INTERMEDIARIO}
      t_numerador:=xv3*N.x + yv3*N.y + zv3*N.z;
      if y2>y1 then begin
         aux1 := x1;
         aux2 := y1;
         y1 := y2;
         x1 := x2;
         y2 := aux2;
         x2 := aux1;
      end;
      if y3>y1 then begin
         aux1 := x1;
         aux2 := y1;
         y1 := y3;
         x1 := x3;
         y3 := aux2;
         x3 := aux1;
      end;
      if y3>y2 then begin  {Ponto mais baixo}
         aux1 := x2;
         aux2 := y2;
         y2 := y3;
         x2 := x3;
         y3 := aux2;
         x3 := aux1;
      end;
      if y1=y2 then
         delta12:=0
      else
         delta12:= (x2-x1)/(y1-y2);
      if y2=y3 then
         delta23:=0
      else
         delta23:= (x3-x2)/(y2-y3);
      delta13:= (x3-x1)/(y1-y3);
   end;
end;


procedure finaliza;
begin
   Ode.copia(tOde);
   Odi.copia(tOdi);
   Caux.Free;
   Id.Free;
   I.Free;
   Isp.Free;
   Ospc.Free;
   Odif.Free;
   tOdi.Free;
   tOde.Free;
   L.Free;
   R.Free;
   V.Free;
   Wt.Free;
   Np.Free;
   P.Free;
   Pproj.Free;
end;

procedure preparaOd;
var fx,fy:real;
    i,j:integer;
    Cor:Longint;
begin
   Wt.carrega(P,TP00);
   Wt.carrega_projecao(TVz);
   Pproj.carrega(P.x,P.y,P.z);
   Pproj.menos(Wt);
   Wt.carrega(Pproj,TP00);
   fx:=Wt.cprojecao(TVx);
   fy:=Wt.cprojecao(TVy);
   i:=trunc(fx*Textura.Width);
   j:=Textura.Height-trunc(fy*Textura.Height);
   Cor:=ColorToRGB(Textura.Canvas.Pixels[i,j]);
   Odi.carrega(GetRValue(Cor),GetGValue(Cor),GetBValue(Cor));
   Ode.carrega(Odi.r,Odi.g,Odi.b);
end;

procedure varredura;
var yscan,x:integer;
begin
   xmin:=round(Rxmin);
   xmax:=round(Rxmax);
   if xmin<0 then xmin:=0;
   if xmax>Largura-1 then xmax:=Largura-1;
   if ymin<0 then ymin:=0;
   for yscan:=ymax downto ymin do begin
      py:=(yscan/meia_altura - 1)*Camera1.hy;
      xr:=Rxmin - xmin;
      xb:=Rxmax - xmax;
      if xmin=xmax then dx:=0
      else dx:=(xb - xr)/(xmax - xmin);
      for x:=xmin to xmax do begin
         px:=((x+xr+(x-xmin)*dx)/meia_largura - 1)*Camera1.hx;
         t:=t_numerador/(px*N.x + py*N.y + Camera1.d*N.z);
         coordenadas_baricentricas(xv1,yv1,xv2,yv2,xv3,yv3,t*px,t*py,alfa,beta,gama);
         if ((alfa>0)or(abs(alfa)<PEQUENO))and((beta>0)or(abs(beta)<PEQUENO))
            and ((gama>0)or(abs(gama)<PEQUENO)) then begin
            z:=alfa*zv1 + beta*zv2 + gama*zv3;
            if (z < z_buffer.pixel[x,yscan]) then begin
               z_buffer.pixel[x,yscan]:=z;
               P.x:=alfa*xv1 + beta*xv2 + gama*xv3;
               P.y:=alfa*yv1 + beta*yv2 + gama*yv3;
               P.z:=alfa*zv1 + beta*zv2 + gama*zv3;
               Np.x:=alfa*N1.x + beta*N2.x + gama*N3.x;
               Np.y:=alfa*N1.y + beta*N2.y + gama*N3.y;
               Np.z:=alfa*N1.z + beta*N2.z + gama*N3.z;
               preparaOd;
               equacao_iluminacao(I,Caux,Id,Isp,Ospc,Odif,Np,L,R,V,P);
               Bitmap.Canvas.Pixels[x,Altura-yscan] := RGB(trunc(I.r),trunc(I.g),trunc(I.b));
            end;
         end;
      end;
      Rxmin:=Rxmin+deltaMin;
      Rxmax:=Rxmax+deltaMax;
      xmin:= round(Rxmin);
      xmax:= round(Rxmax);
      if xmin<0 then xmin:=0;
      if xmax>Largura-1 then xmax:=Largura-1;
   end;
end;


begin
   preambulo;
   if y1=y2 then begin
      deltaMin:=delta13;
      deltaMax:=delta23;
      xmin:=x1;
      xmax:=x2;
      if delta13<delta23 then begin
         deltaMin:=delta23;
         deltaMax:=delta13;
         xmin:=x2;
         xmax:=x1;
      end;
      ymin:=y3;
      ymax:=y1;
      Rxmin := xmin;
      Rxmax := xmax;
      if ymax>Altura-1 then begin
         ymax:=Altura-1;
         Rxmin:=-deltaMin*(Altura-1-ymax)+xmin;
         Rxmax:=-deltaMax*(Altura-1-ymax)+xmax;
      end;
      varredura;
   end
   else begin
      deltaMin:=delta12;
      deltaMax:=delta13;
      if delta13<delta12 then begin
         deltaMin:=delta13;
         deltaMax:=delta12;
      end;
      Rxmin := x1;
      Rxmax := x1;
      ymin:=y2;
      ymax:=y1;
      if ymax>Altura-1 then begin
         ymax:=Altura-1;
         Rxmin:=-deltaMin*(Altura-1-y1)+x1;
         Rxmax:=-deltaMax*(Altura-1-y1)+x1;
      end;
      varredura;
      Rxmin:=Rxmin-deltaMin;
      Rxmax:=Rxmax-deltaMax;
      if y2<>y3 then begin
         deltaMin:=delta13;
         deltaMax:=delta23;
         if delta13<delta23 then begin
            deltaMin:=delta23;
            deltaMax:=delta13;
         end;
         ymin:=y3;
         ymax:=y2;
         if ymax>Altura-1 then begin
            ymax:=Altura-1;
            if delta13>delta23 then begin
               Rxmin:=-deltaMin*(Altura-1-y1)+x1;
               Rxmax:=-deltaMax*(Altura-1-y2)+x2;
            end
            else begin
               Rxmin:=-deltaMin*(Altura-1-y2)+x2;
               Rxmax:=-deltaMax*(Altura-1-y1)+x1;
            end;
         end;
         varredura;
      end;
   end;
   finaliza;
   tscanconvert:=BitMap;
end;




procedure ilumina_triangulo_phong(xv0,yv0,zv0,xv1,yv1,zv1,xv2,yv2,zv2:real;
                                    N0,N1,N2,N:vetor);
begin
   BitMap:=scanconvert(xv0,yv0,zv0,xv1,yv1,zv1,xv2,yv2,zv2,N0,N1,N2,N);
end;

procedure tilumina_triangulo_phong(xv0,yv0,zv0,xv1,yv1,zv1,xv2,yv2,zv2:real;
                                    N0,N1,N2,N:vetor;comText:Boolean);
begin
   if comText then
      BitMap:=tscanconvert(xv0,yv0,zv0,xv1,yv1,zv1,xv2,yv2,zv2,N0,N1,N2,N)
   else
      BitMap:=scanconvert(xv0,yv0,zv0,xv1,yv1,zv1,xv2,yv2,zv2,N0,N1,N2,N);
end;



function phong_shading:TBitmap;
var i,k,A,B,C:integer;
    T:Triangulo;
    corte:short;
    Vtmp:vetor;
    Kab,Kac,Kbc,xc0,yc0,xc1,yc1:real;
    N0,N1,N:vetor;
begin

   Bitmap.Canvas.Pen.Color:=RGB(255,255,0);
   Vtmp:=vetor.create(0,0,0);
   N0:=vetor.create(0,0,0);
   N1:=vetor.create(0,0,0);
   Bitmap.Canvas.Brush.Color:=RGB(0,0,0);
   Bitmap.Canvas.Rectangle(1,1,Largura,Altura);
   obter_distancias;
   LTriangulos.Sort(compare);
   for i:=LTriangulos.Count-1 downto 0 do begin
      T:=LTriangulos[i];
      T.computa_normal(LPontos,Vtmp);
   end;
   prepara_listas_de_normais;
   computa_normais_nos_pontos;

   for i:=0 to LTriangulos.Count-1 do begin
      T:=LTriangulos[i];
      A:=T.A - 1;
      B:=T.B - 1;
      C:=T.C - 1;
      N:=T.Normal;
      corte:=corte_triangulo_3D(T,Kab,Kac,Kbc);
      if corte>=0 then begin
         case corte of
            0:ilumina_triangulo_phong(LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                     LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                     LNormais[A],LNormais[B],LNormais[C],N);
            1:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc1:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 N0.carrega(LNormais[A].x + Kab*(LNormais[B].x - LNormais[A].x),
                            LNormais[A].y + Kab*(LNormais[B].y - LNormais[A].y),
                            LNormais[A].z + Kab*(LNormais[B].z - LNormais[A].z));
                 N1.carrega(LNormais[A].x + Kac*(LNormais[C].x - LNormais[A].x),
                            LNormais[A].y + Kac*(LNormais[C].y - LNormais[A].y),
                            LNormais[A].z + Kac*(LNormais[C].z - LNormais[A].z));
                 ilumina_triangulo_phong(LPontos[B].x,LPontos[B].y,LPontos[B].z,
                         xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,LNormais[B],N0,N1,N);
                 ilumina_triangulo_phong(LPontos[B].x,LPontos[B].y,LPontos[B].z,
                             LPontos[C].x,LPontos[C].y,LPontos[C].z,
                             xc1,yc1,Camera1.d,LNormais[B],LNormais[C],N1,N);

              end;
            2:begin
                 xc0:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 N0.carrega(LNormais[A].x + Kac*(LNormais[C].x - LNormais[A].x),
                            LNormais[A].y + Kac*(LNormais[C].y - LNormais[A].y),
                            LNormais[A].z + Kac*(LNormais[C].z - LNormais[A].z));
                 N1.carrega(LNormais[B].x + Kbc*(LNormais[C].x - LNormais[B].x),
                            LNormais[B].y + Kbc*(LNormais[C].y - LNormais[B].y),
                            LNormais[B].z + Kbc*(LNormais[C].z - LNormais[B].z));
                 ilumina_triangulo_phong(xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                    N0,N1,LNormais[C],N);
               end;
            3:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 N0.carrega(LNormais[A].x + Kab*(LNormais[B].x - LNormais[A].x),
                            LNormais[A].y + Kab*(LNormais[B].y - LNormais[A].y),
                            LNormais[A].z + Kab*(LNormais[B].z - LNormais[A].z));
                 N1.carrega(LNormais[B].x + Kbc*(LNormais[C].x - LNormais[B].x),
                            LNormais[B].y + Kbc*(LNormais[C].y - LNormais[B].y),
                            LNormais[B].z + Kbc*(LNormais[C].z - LNormais[B].z));
                 ilumina_triangulo_phong(xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                    N0,N1,LNormais[B],N);
               end;
            4:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 N0.carrega(LNormais[A].x + Kab*(LNormais[B].x - LNormais[A].x),
                            LNormais[A].y + Kab*(LNormais[B].y - LNormais[A].y),
                            LNormais[A].z + Kab*(LNormais[B].z - LNormais[A].z));
                 N1.carrega(LNormais[B].x + Kbc*(LNormais[C].x - LNormais[B].x),
                            LNormais[B].y + Kbc*(LNormais[C].y - LNormais[B].y),
                            LNormais[B].z + Kbc*(LNormais[C].z - LNormais[B].z));

                 ilumina_triangulo_phong(xc0,yc0,Camera1.d,
                                    LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                    N0,LNormais[A],LNormais[C],N);
                 ilumina_triangulo_phong(xc0,yc0,Camera1.d,
                                    xc1,yc1,Camera1.d,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                    N0,N1,LNormais[C],N);
              end;
            5:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc1:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 N0.carrega(LNormais[A].x + Kab*(LNormais[B].x - LNormais[A].x),
                            LNormais[A].y + Kab*(LNormais[B].y - LNormais[A].y),
                            LNormais[A].z + Kab*(LNormais[B].z - LNormais[A].z));
                 N1.carrega(LNormais[A].x + Kac*(LNormais[C].x - LNormais[A].x),
                            LNormais[A].y + Kac*(LNormais[C].y - LNormais[A].y),
                            LNormais[A].z + Kac*(LNormais[C].z - LNormais[A].z));
                 ilumina_triangulo_phong(xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                    LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    N0,N1,LNormais[A],N);
               end;
            6:begin
                 xc0:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 N0.carrega(LNormais[A].x + Kac*(LNormais[C].x - LNormais[A].x),
                            LNormais[A].y + Kac*(LNormais[C].y - LNormais[A].y),
                            LNormais[A].z + Kac*(LNormais[C].z - LNormais[A].z));
                 N1.carrega(LNormais[B].x + Kbc*(LNormais[C].x - LNormais[B].x),
                            LNormais[B].y + Kbc*(LNormais[C].y - LNormais[B].y),
                            LNormais[B].z + Kbc*(LNormais[C].z - LNormais[B].z));

                 ilumina_triangulo_phong(xc0,yc0,Camera1.d,
                                    LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                    N0,LNormais[A],LNormais[B],N);
                 ilumina_triangulo_phong(xc0,yc0,Camera1.d,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                     xc1,yc1,Camera1.d,N0,LNormais[B],N1,N);
              end;
         end;
      end;
   end;
   Vtmp.Free;
   N0.Free;
   N1.Free;
   result:=Bitmap;
end;


function tphong_shading:TBitmap;
var i,k,A,B,C:integer;
    T:Triangulo;
    corte:short;
    Vtmp:vetor;
    Kab,Kac,Kbc,xc0,yc0,xc1,yc1:real;
    N0,N1,N:vetor;
begin

   Bitmap.Canvas.Pen.Color:=RGB(255,255,0);
   Vtmp:=vetor.create(0,0,0);
   N0:=vetor.create(0,0,0);
   N1:=vetor.create(0,0,0);
   Bitmap.Canvas.Brush.Color:=RGB(0,0,0);
   Bitmap.Canvas.Rectangle(1,1,Largura,Altura);
   obter_distancias;
 //  LTriangulos.Sort(compare);
   for i:=LTriangulos.Count-1 downto 0 do begin
      T:=LTriangulos[i];
      T.computa_normal(LPontos,Vtmp);
   end;
   prepara_listas_de_normais;
   computa_normais_nos_pontos;

   for i:=0 to LTriangulos.Count-1 do begin
      T:=LTriangulos[i];
      A:=T.A - 1;
      B:=T.B - 1;
      C:=T.C - 1;
      N:=T.Normal;
      corte:=corte_triangulo_3D(T,Kab,Kac,Kbc);
      if corte>=0 then begin
         case corte of
            0:tilumina_triangulo_phong(LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                    LNormais[A],LNormais[B],LNormais[C],N,
                                     (tFacei<=i+1)and(i+1<=tFacef));
            1:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc1:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 N0.carrega(LNormais[A].x + Kab*(LNormais[B].x - LNormais[A].x),
                            LNormais[A].y + Kab*(LNormais[B].y - LNormais[A].y),
                            LNormais[A].z + Kab*(LNormais[B].z - LNormais[A].z));
                 N1.carrega(LNormais[A].x + Kac*(LNormais[C].x - LNormais[A].x),
                            LNormais[A].y + Kac*(LNormais[C].y - LNormais[A].y),
                            LNormais[A].z + Kac*(LNormais[C].z - LNormais[A].z));
                 tilumina_triangulo_phong(LPontos[B].x,LPontos[B].y,LPontos[B].z,
                         xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,LNormais[B],N0,N1,N,
                                                  (tFacei<=i+1)and(i+1<=tFacef));
                 tilumina_triangulo_phong(LPontos[B].x,LPontos[B].y,LPontos[B].z,
                             LPontos[C].x,LPontos[C].y,LPontos[C].z,
                             xc1,yc1,Camera1.d,LNormais[B],LNormais[C],N1,N,
                                                  (tFacei<=i+1)and(i+1<=tFacef));

              end;
            2:begin
                 xc0:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 N0.carrega(LNormais[A].x + Kac*(LNormais[C].x - LNormais[A].x),
                            LNormais[A].y + Kac*(LNormais[C].y - LNormais[A].y),
                            LNormais[A].z + Kac*(LNormais[C].z - LNormais[A].z));
                 N1.carrega(LNormais[B].x + Kbc*(LNormais[C].x - LNormais[B].x),
                            LNormais[B].y + Kbc*(LNormais[C].y - LNormais[B].y),
                            LNormais[B].z + Kbc*(LNormais[C].z - LNormais[B].z));
                 tilumina_triangulo_phong(xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                 N0,N1,LNormais[C],N,(tFacei<=i+1)and(i+1<=tFacef));
              end;
            3:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 N0.carrega(LNormais[A].x + Kab*(LNormais[B].x - LNormais[A].x),
                            LNormais[A].y + Kab*(LNormais[B].y - LNormais[A].y),
                            LNormais[A].z + Kab*(LNormais[B].z - LNormais[A].z));
                 N1.carrega(LNormais[B].x + Kbc*(LNormais[C].x - LNormais[B].x),
                            LNormais[B].y + Kbc*(LNormais[C].y - LNormais[B].y),
                            LNormais[B].z + Kbc*(LNormais[C].z - LNormais[B].z));
                 tilumina_triangulo_phong(xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,N0,N1,
                                    LNormais[B],N,(tFacei<=i+1)and(i+1<=tFacef));
               end;
            4:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 N0.carrega(LNormais[A].x + Kab*(LNormais[B].x - LNormais[A].x),
                            LNormais[A].y + Kab*(LNormais[B].y - LNormais[A].y),
                            LNormais[A].z + Kab*(LNormais[B].z - LNormais[A].z));
                 N1.carrega(LNormais[B].x + Kbc*(LNormais[C].x - LNormais[B].x),
                            LNormais[B].y + Kbc*(LNormais[C].y - LNormais[B].y),
                            LNormais[B].z + Kbc*(LNormais[C].z - LNormais[B].z));

                 tilumina_triangulo_phong(xc0,yc0,Camera1.d,
                                    LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                    N0,LNormais[A],LNormais[C],N,
                                    (tFacei<=i+1)and(i+1<=tFacef));
                 tilumina_triangulo_phong(xc0,yc0,Camera1.d,
                                    xc1,yc1,Camera1.d,
                                    LPontos[C].x,LPontos[C].y,LPontos[C].z,
                                    N0,N1,LNormais[C],N,
                                    (tFacei<=i+1)and(i+1<=tFacef));
              end;
            5:begin
                 xc0:=LPontos[A].x + Kab*(LPontos[B].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kab*(LPontos[B].y - LPontos[A].y);
                 xc1:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc1:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 N0.carrega(LNormais[A].x + Kab*(LNormais[B].x - LNormais[A].x),
                            LNormais[A].y + Kab*(LNormais[B].y - LNormais[A].y),
                            LNormais[A].z + Kab*(LNormais[B].z - LNormais[A].z));
                 N1.carrega(LNormais[A].x + Kac*(LNormais[C].x - LNormais[A].x),
                            LNormais[A].y + Kac*(LNormais[C].y - LNormais[A].y),
                            LNormais[A].z + Kac*(LNormais[C].z - LNormais[A].z));
                 tilumina_triangulo_phong(xc0,yc0,Camera1.d,xc1,yc1,Camera1.d,
                                    LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    N0,N1,LNormais[A],N,
                                    (tFacei<=i+1)and(i+1<=tFacef));
               end;
            6:begin
                 xc0:=LPontos[A].x + Kac*(LPontos[C].x - LPontos[A].x);
                 yc0:=LPontos[A].y + Kac*(LPontos[C].y - LPontos[A].y);
                 xc1:=LPontos[B].x + Kbc*(LPontos[C].x - LPontos[B].x);
                 yc1:=LPontos[B].y + Kbc*(LPontos[C].y - LPontos[B].y);
                 N0.carrega(LNormais[A].x + Kac*(LNormais[C].x - LNormais[A].x),
                            LNormais[A].y + Kac*(LNormais[C].y - LNormais[A].y),
                            LNormais[A].z + Kac*(LNormais[C].z - LNormais[A].z));
                 N1.carrega(LNormais[B].x + Kbc*(LNormais[C].x - LNormais[B].x),
                            LNormais[B].y + Kbc*(LNormais[C].y - LNormais[B].y),
                            LNormais[B].z + Kbc*(LNormais[C].z - LNormais[B].z));

                 tilumina_triangulo_phong(xc0,yc0,Camera1.d,
                                    LPontos[A].x,LPontos[A].y,LPontos[A].z,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                    N0,LNormais[A],LNormais[B],N,
                                    (tFacei<=i+1)and(i+1<=tFacef));
                 tilumina_triangulo_phong(xc0,yc0,Camera1.d,
                                    LPontos[B].x,LPontos[B].y,LPontos[B].z,
                                     xc1,yc1,Camera1.d,N0,LNormais[B],N1,N,
                                     (tFacei<=i+1)and(i+1<=tFacef));
              end;
         end;
      end;
   end;
   Vtmp.Free;
   N0.Free;
   N1.Free;
   result:=Bitmap;
end;



end.





