unit uTriangulo;

interface
uses Classes,Windows,Graphics,ExtCtrls,Forms,SysUtils,Math,uInstrumental_Basico;


Type
ListaDePontos = array of Ponto;

Triangulo = Class
  Public
  A,B,C,tet:integer;
  dist_2:real;
  Normal:Vetor;
  constructor create(A1,B1,C1:integer);
  procedure computa_normal(LPts:ListaDePontos;Vtmp:vetor);
  procedure carrega(A1,B1,C1:integer);
end;

Var
    NTriangulos:Integer;
    NTriangulosAux:Integer;

    LTriangulos:TList;
    LTriangulosAux:TList;

    NPontos:Integer;
    NPontosAux:Integer;

    LPontos: ListaDePontos;
    LPontosAux: ListaDePontos;

    LNormais:array of vetor;
    LCores:array of Cor;


procedure obter_distancias;
procedure prepara_listas;
procedure prepara_listas_de_normais;
function compare(P1,P2:Pointer):integer;
procedure computa_normais_nos_pontos;


implementation

procedure Triangulo.carrega(A1,B1,C1:integer);
begin
  A:=A1; B:=B1; C:=C1;
end;

procedure Triangulo.computa_normal(LPts:ListaDePontos;Vtmp:vetor);
var
    k:real;
begin
  Normal.carrega(LPts[B-1],LPts[A-1]);
  Vtmp.carrega(LPts[C-1],LPts[A-1]);
  Normal.vezes(Vtmp);
  Normal.normalizado;
end;

constructor Triangulo.create(A1,B1,C1:integer);
begin
  inherited create;
  Normal:=Vetor.create(0,0,0);
  carrega(A1,B1,C1);
  tet:=0;
end;

procedure prepara_listas;
var Tngl:Triangulo;
    i:integer;
    pt:Ponto;
    v:vetor;
    c:cor;
begin
  if LNormais <> nil then begin
    for i:=0 to NPontos-1 do begin
       v:=LNormais[i];
       v.Free;
    end;
    LNormais:=nil;
    if LCores<>nil then begin
       for i:=0 to NPontos-1 do begin
          c:=LCores[i];
          c.Free;
       end;
       LCores:=nil;
    end;
  end;
  if LPontos <> nil then begin
    for i:=0 to NPontos-1 do begin
       pt:=LPontos[i];
       pt.Free;
    end;
    LPontos:=nil;
    NPontos:=0;
  end;
  if LTriangulos<>nil then begin
     for i:=0 to LTriangulos.count-1 do begin
        Tngl:=LTriangulos[i];
        Tngl.Free;
     end;
  end;
end;

procedure prepara_listas_de_normais;
var
    i:integer;
begin
  SetLength(LNormais,NPontos);
  for i:=0 to NPontos-1 do
     LNormais[i]:=vetor.create(0,0,0);
end;

procedure computa_normais_nos_pontos;
var i:integer;
    T:Triangulo;
begin
   for i:=LTriangulos.Count-1 downto 0 do begin
      T:=LTriangulos[i];
      LNormais[T.A - 1].mais(T.Normal);
      LNormais[T.B - 1].mais(T.Normal);
      LNormais[T.C - 1].mais(T.Normal);
   end;
   for i:=0 to NPontos-1 do
     LNormais[i].normalizado;
end;

procedure obter_distancias;
var i:integer;
    T:Triangulo;
    v1,v2:vetor;
    Baricentro:ponto;
begin
   v1:=vetor.create(0,0,0);
   v2:=vetor.create(0,0,0);
   Baricentro:=Ponto.Create(0,0,0);
   for i:=0 to LTriangulos.Count-1 do begin
      T:=LTriangulos[i];
      Baricentro.copia(LPontos[T.C-1]);
      v1.carrega(LPontos[T.A-1],LPontos[T.C-1]);
      v2.carrega(LPontos[T.B-1],LPontos[T.C-1]);
      v1.vezes(1.0/3.0);
      v2.vezes(1.0/3.0);
      Baricentro.mais(v1);
      Baricentro.mais(v2);
      T.dist_2:=Baricentro.x * Baricentro.x +
                Baricentro.y * Baricentro.y +
                Baricentro.z * Baricentro.z;
   end;
   v1.Free;
   v2.Free;
   Baricentro.Free;
end;

function compare(P1,P2:Pointer):integer;
var T1,T2:Triangulo;
begin
   T1:=P1;
   T2:=P2;
   if T1.dist_2 < T2.dist_2 then result:=-1
   else
      if T1.dist_2 > T2.dist_2 then result:=1
      else result:=0;
end;


end.
